/*!
[config]
name: Test short rhadd built-in on CL 1.1
clc_version_min: 10
dimensions: 1

[test]
name: rhadd short1
kernel_name: test_1_rhadd_short
global_size: 4 0 0

arg_out: 0 buffer short[4] 33 1 10 -32  tolerance 0 
arg_in: 1 buffer short[4] 32 1 12 -33 
arg_in: 2 buffer short[4] 33 0 8 -32 

[test]
name: rhadd short2
kernel_name: test_2_rhadd_short
global_size: 4 0 0

arg_out: 0 buffer short[8] 33 33 1 1 10 10 -32 -32  tolerance 0 
arg_in: 1 buffer short[8] 32 32 1 1 12 12 -33 -33 
arg_in: 2 buffer short[8] 33 33 0 0 8 8 -32 -32 

[test]
name: rhadd short4
kernel_name: test_4_rhadd_short
global_size: 4 0 0

arg_out: 0 buffer short[16] 33 33 33 33 1 1 1 1 10 10 10 10 -32 -32 -32 -32  tolerance 0 
arg_in: 1 buffer short[16] 32 32 32 32 1 1 1 1 12 12 12 12 -33 -33 -33 -33 
arg_in: 2 buffer short[16] 33 33 33 33 0 0 0 0 8 8 8 8 -32 -32 -32 -32 

[test]
name: rhadd short8
kernel_name: test_8_rhadd_short
global_size: 4 0 0

arg_out: 0 buffer short[32] 33 33 33 33 33 33 33 33 1 1 1 1 1 1 1 1 10 10 10 10 10 10 10 10 -32 -32 -32 -32 -32 -32 -32 -32  tolerance 0 
arg_in: 1 buffer short[32] 32 32 32 32 32 32 32 32 1 1 1 1 1 1 1 1 12 12 12 12 12 12 12 12 -33 -33 -33 -33 -33 -33 -33 -33 
arg_in: 2 buffer short[32] 33 33 33 33 33 33 33 33 0 0 0 0 0 0 0 0 8 8 8 8 8 8 8 8 -32 -32 -32 -32 -32 -32 -32 -32 

[test]
name: rhadd short16
kernel_name: test_16_rhadd_short
global_size: 4 0 0

arg_out: 0 buffer short[64] 33 33 33 33 33 33 33 33 33 33 33 33 33 33 33 33 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 -32 -32 -32 -32 -32 -32 -32 -32 -32 -32 -32 -32 -32 -32 -32 -32  tolerance 0 
arg_in: 1 buffer short[64] 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 -33 -33 -33 -33 -33 -33 -33 -33 -33 -33 -33 -33 -33 -33 -33 -33 
arg_in: 2 buffer short[64] 33 33 33 33 33 33 33 33 33 33 33 33 33 33 33 33 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 -32 -32 -32 -32 -32 -32 -32 -32 -32 -32 -32 -32 -32 -32 -32 -32 

!*/

kernel void test_1_rhadd_short(global short* out, global short* in0, global short* in1){
  out[get_global_id(0)] = rhadd(in0[get_global_id(0)], in1[get_global_id(0)]);
}

kernel void test_2_rhadd_short(global short* out, global short* in0, global short* in1){
  vstore2(rhadd(vload2(get_global_id(0), in0), vload2(get_global_id(0), in1)), get_global_id(0), out);
}

kernel void test_4_rhadd_short(global short* out, global short* in0, global short* in1){
  vstore4(rhadd(vload4(get_global_id(0), in0), vload4(get_global_id(0), in1)), get_global_id(0), out);
}

kernel void test_8_rhadd_short(global short* out, global short* in0, global short* in1){
  vstore8(rhadd(vload8(get_global_id(0), in0), vload8(get_global_id(0), in1)), get_global_id(0), out);
}

kernel void test_16_rhadd_short(global short* out, global short* in0, global short* in1){
  vstore16(rhadd(vload16(get_global_id(0), in0), vload16(get_global_id(0), in1)), get_global_id(0), out);
}

