/*!
[config]
name: Vector store local short2,3,4,8,16
clc_version_min: 11

dimensions: 1
global_size: 1 0 0

[test]
name: vector store local short2
kernel_name: vstore2_local
arg_out: 0 buffer short[4] 0 28 46 0xdead
arg_in: 0 buffer short[4] 0 0 0  0xdead
arg_in:  1 buffer short2[1] 28 46

[test]
name: vector store local offset short2
kernel_name: vstore2_local_offset
arg_out: 0 buffer short[6] 0  28 46  28 46 0xdead
arg_in: 0 buffer short[6] 0 0 0 0 0  0xdead
arg_in: 1 buffer short2[1] 28 46

[test]
name: vector store local short3
kernel_name: vstore3_local
arg_out: 0 buffer short[5] 0 121 66 189 0xdead
arg_in: 0 buffer short[5] 0 0 0 0  0xdead
arg_in:  1 buffer short3[1] 121 66 189

[test]
name: vector store local offset short3
kernel_name: vstore3_local_offset
arg_out: 0 buffer short[8] 0  121 66 189  121 66 189 0xdead
arg_in: 0 buffer short[8] 0 0 0 0 0 0 0  0xdead
arg_in: 1 buffer short3[1] 121 66 189

[test]
name: vector store local short4
kernel_name: vstore4_local
arg_out: 0 buffer short[6] 0 120 155 52 202 0xdead
arg_in: 0 buffer short[6] 0 0 0 0 0  0xdead
arg_in:  1 buffer short4[1] 120 155 52 202

[test]
name: vector store local offset short4
kernel_name: vstore4_local_offset
arg_out: 0 buffer short[10] 0  120 155 52 202  120 155 52 202 0xdead
arg_in: 0 buffer short[10] 0 0 0 0 0 0 0 0 0  0xdead
arg_in: 1 buffer short4[1] 120 155 52 202

[test]
name: vector store local short8
kernel_name: vstore8_local
arg_out: 0 buffer short[10] 0 116 189 192 64 98 22 43 70 0xdead
arg_in: 0 buffer short[10] 0 0 0 0 0 0 0 0 0  0xdead
arg_in:  1 buffer short8[1] 116 189 192 64 98 22 43 70

[test]
name: vector store local offset short8
kernel_name: vstore8_local_offset
arg_out: 0 buffer short[18] 0  116 189 192 64 98 22 43 70  116 189 192 64 98 22 43 70 0xdead
arg_in: 0 buffer short[18] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0xdead
arg_in: 1 buffer short8[1] 116 189 192 64 98 22 43 70

[test]
name: vector store local short16
kernel_name: vstore16_local
arg_out: 0 buffer short[18] 0 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171 0xdead
arg_in: 0 buffer short[18] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0xdead
arg_in:  1 buffer short16[1] 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171

[test]
name: vector store local offset short16
kernel_name: vstore16_local_offset
arg_out: 0 buffer short[34] 0  185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171  185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171 0xdead
arg_in: 0 buffer short[34] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0xdead
arg_in: 1 buffer short16[1] 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171

!*/

kernel void vstore2_local(global short *out,
                             global short2 *in) {
    short2 tmp = in[0];
    volatile local short loc[3];
    for (int i = 0; i < 3; ++i)
        loc[i] = (short)0;

    vstore2(tmp, 0, (local short*)loc + 1);
    for (int i = 0; i < 3; ++i)
        out[i] = loc[i];
}

kernel void vstore2_local_offset(global short *out,
                                    global short2 *in) {
    short2 tmp = in[0];
    volatile local short loc[5];
    for (int i = 0; i < 5; ++i)
        loc[i] = (short)0;

    vstore2(tmp, 0, (local short*)loc + 1);
    vstore2(tmp, 1, (local short*)loc + 1);
    for (int i = 0; i < 5; ++i)
        out[i] = loc[i];
}

kernel void vstore3_local(global short *out,
                             global short3 *in) {
    short3 tmp = in[0];
    volatile local short loc[4];
    for (int i = 0; i < 4; ++i)
        loc[i] = (short)0;

    vstore3(tmp, 0, (local short*)loc + 1);
    for (int i = 0; i < 4; ++i)
        out[i] = loc[i];
}

kernel void vstore3_local_offset(global short *out,
                                    global short3 *in) {
    short3 tmp = in[0];
    volatile local short loc[7];
    for (int i = 0; i < 7; ++i)
        loc[i] = (short)0;

    vstore3(tmp, 0, (local short*)loc + 1);
    vstore3(tmp, 1, (local short*)loc + 1);
    for (int i = 0; i < 7; ++i)
        out[i] = loc[i];
}

kernel void vstore4_local(global short *out,
                             global short4 *in) {
    short4 tmp = in[0];
    volatile local short loc[5];
    for (int i = 0; i < 5; ++i)
        loc[i] = (short)0;

    vstore4(tmp, 0, (local short*)loc + 1);
    for (int i = 0; i < 5; ++i)
        out[i] = loc[i];
}

kernel void vstore4_local_offset(global short *out,
                                    global short4 *in) {
    short4 tmp = in[0];
    volatile local short loc[9];
    for (int i = 0; i < 9; ++i)
        loc[i] = (short)0;

    vstore4(tmp, 0, (local short*)loc + 1);
    vstore4(tmp, 1, (local short*)loc + 1);
    for (int i = 0; i < 9; ++i)
        out[i] = loc[i];
}

kernel void vstore8_local(global short *out,
                             global short8 *in) {
    short8 tmp = in[0];
    volatile local short loc[9];
    for (int i = 0; i < 9; ++i)
        loc[i] = (short)0;

    vstore8(tmp, 0, (local short*)loc + 1);
    for (int i = 0; i < 9; ++i)
        out[i] = loc[i];
}

kernel void vstore8_local_offset(global short *out,
                                    global short8 *in) {
    short8 tmp = in[0];
    volatile local short loc[17];
    for (int i = 0; i < 17; ++i)
        loc[i] = (short)0;

    vstore8(tmp, 0, (local short*)loc + 1);
    vstore8(tmp, 1, (local short*)loc + 1);
    for (int i = 0; i < 17; ++i)
        out[i] = loc[i];
}

kernel void vstore16_local(global short *out,
                             global short16 *in) {
    short16 tmp = in[0];
    volatile local short loc[17];
    for (int i = 0; i < 17; ++i)
        loc[i] = (short)0;

    vstore16(tmp, 0, (local short*)loc + 1);
    for (int i = 0; i < 17; ++i)
        out[i] = loc[i];
}

kernel void vstore16_local_offset(global short *out,
                                    global short16 *in) {
    short16 tmp = in[0];
    volatile local short loc[33];
    for (int i = 0; i < 33; ++i)
        loc[i] = (short)0;

    vstore16(tmp, 0, (local short*)loc + 1);
    vstore16(tmp, 1, (local short*)loc + 1);
    for (int i = 0; i < 33; ++i)
        out[i] = loc[i];
}
