/*!
[config]
name: Vector store private uint2,3,4,8,16
clc_version_min: 11

dimensions: 1
global_size: 1 0 0

[test]
name: vector store private uint2
kernel_name: vstore2_private
arg_out: 0 buffer uint[4] 0 28 46 0xdead
arg_in: 0 buffer uint[4] 0 0 0  0xdead
arg_in:  1 buffer uint2[1] 28 46

[test]
name: vector store private offset uint2
kernel_name: vstore2_private_offset
arg_out: 0 buffer uint[6] 0  28 46  28 46 0xdead
arg_in: 0 buffer uint[6] 0 0 0 0 0  0xdead
arg_in: 1 buffer uint2[1] 28 46

[test]
name: vector store private uint3
kernel_name: vstore3_private
arg_out: 0 buffer uint[5] 0 121 66 189 0xdead
arg_in: 0 buffer uint[5] 0 0 0 0  0xdead
arg_in:  1 buffer uint3[1] 121 66 189

[test]
name: vector store private offset uint3
kernel_name: vstore3_private_offset
arg_out: 0 buffer uint[8] 0  121 66 189  121 66 189 0xdead
arg_in: 0 buffer uint[8] 0 0 0 0 0 0 0  0xdead
arg_in: 1 buffer uint3[1] 121 66 189

[test]
name: vector store private uint4
kernel_name: vstore4_private
arg_out: 0 buffer uint[6] 0 120 155 52 202 0xdead
arg_in: 0 buffer uint[6] 0 0 0 0 0  0xdead
arg_in:  1 buffer uint4[1] 120 155 52 202

[test]
name: vector store private offset uint4
kernel_name: vstore4_private_offset
arg_out: 0 buffer uint[10] 0  120 155 52 202  120 155 52 202 0xdead
arg_in: 0 buffer uint[10] 0 0 0 0 0 0 0 0 0  0xdead
arg_in: 1 buffer uint4[1] 120 155 52 202

[test]
name: vector store private uint8
kernel_name: vstore8_private
arg_out: 0 buffer uint[10] 0 116 189 192 64 98 22 43 70 0xdead
arg_in: 0 buffer uint[10] 0 0 0 0 0 0 0 0 0  0xdead
arg_in:  1 buffer uint8[1] 116 189 192 64 98 22 43 70

[test]
name: vector store private offset uint8
kernel_name: vstore8_private_offset
arg_out: 0 buffer uint[18] 0  116 189 192 64 98 22 43 70  116 189 192 64 98 22 43 70 0xdead
arg_in: 0 buffer uint[18] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0xdead
arg_in: 1 buffer uint8[1] 116 189 192 64 98 22 43 70

[test]
name: vector store private uint16
kernel_name: vstore16_private
arg_out: 0 buffer uint[18] 0 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171 0xdead
arg_in: 0 buffer uint[18] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0xdead
arg_in:  1 buffer uint16[1] 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171

[test]
name: vector store private offset uint16
kernel_name: vstore16_private_offset
arg_out: 0 buffer uint[34] 0  185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171  185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171 0xdead
arg_in: 0 buffer uint[34] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0  0xdead
arg_in: 1 buffer uint16[1] 185 240 246 145 213 116 228 2 209 132 121 113 5 151 154 171

!*/

kernel void vstore2_private(global uint *out,
                             global uint2 *in) {
    uint2 tmp = in[0];
    volatile private uint loc[3];
    for (int i = 0; i < 3; ++i)
        loc[i] = (uint)0;

    vstore2(tmp, 0, (private uint*)loc + 1);
    for (int i = 0; i < 3; ++i)
        out[i] = loc[i];
}

kernel void vstore2_private_offset(global uint *out,
                                    global uint2 *in) {
    uint2 tmp = in[0];
    volatile private uint loc[5];
    for (int i = 0; i < 5; ++i)
        loc[i] = (uint)0;

    vstore2(tmp, 0, (private uint*)loc + 1);
    vstore2(tmp, 1, (private uint*)loc + 1);
    for (int i = 0; i < 5; ++i)
        out[i] = loc[i];
}

kernel void vstore3_private(global uint *out,
                             global uint3 *in) {
    uint3 tmp = in[0];
    volatile private uint loc[4];
    for (int i = 0; i < 4; ++i)
        loc[i] = (uint)0;

    vstore3(tmp, 0, (private uint*)loc + 1);
    for (int i = 0; i < 4; ++i)
        out[i] = loc[i];
}

kernel void vstore3_private_offset(global uint *out,
                                    global uint3 *in) {
    uint3 tmp = in[0];
    volatile private uint loc[7];
    for (int i = 0; i < 7; ++i)
        loc[i] = (uint)0;

    vstore3(tmp, 0, (private uint*)loc + 1);
    vstore3(tmp, 1, (private uint*)loc + 1);
    for (int i = 0; i < 7; ++i)
        out[i] = loc[i];
}

kernel void vstore4_private(global uint *out,
                             global uint4 *in) {
    uint4 tmp = in[0];
    volatile private uint loc[5];
    for (int i = 0; i < 5; ++i)
        loc[i] = (uint)0;

    vstore4(tmp, 0, (private uint*)loc + 1);
    for (int i = 0; i < 5; ++i)
        out[i] = loc[i];
}

kernel void vstore4_private_offset(global uint *out,
                                    global uint4 *in) {
    uint4 tmp = in[0];
    volatile private uint loc[9];
    for (int i = 0; i < 9; ++i)
        loc[i] = (uint)0;

    vstore4(tmp, 0, (private uint*)loc + 1);
    vstore4(tmp, 1, (private uint*)loc + 1);
    for (int i = 0; i < 9; ++i)
        out[i] = loc[i];
}

kernel void vstore8_private(global uint *out,
                             global uint8 *in) {
    uint8 tmp = in[0];
    volatile private uint loc[9];
    for (int i = 0; i < 9; ++i)
        loc[i] = (uint)0;

    vstore8(tmp, 0, (private uint*)loc + 1);
    for (int i = 0; i < 9; ++i)
        out[i] = loc[i];
}

kernel void vstore8_private_offset(global uint *out,
                                    global uint8 *in) {
    uint8 tmp = in[0];
    volatile private uint loc[17];
    for (int i = 0; i < 17; ++i)
        loc[i] = (uint)0;

    vstore8(tmp, 0, (private uint*)loc + 1);
    vstore8(tmp, 1, (private uint*)loc + 1);
    for (int i = 0; i < 17; ++i)
        out[i] = loc[i];
}

kernel void vstore16_private(global uint *out,
                             global uint16 *in) {
    uint16 tmp = in[0];
    volatile private uint loc[17];
    for (int i = 0; i < 17; ++i)
        loc[i] = (uint)0;

    vstore16(tmp, 0, (private uint*)loc + 1);
    for (int i = 0; i < 17; ++i)
        out[i] = loc[i];
}

kernel void vstore16_private_offset(global uint *out,
                                    global uint16 *in) {
    uint16 tmp = in[0];
    volatile private uint loc[33];
    for (int i = 0; i < 33; ++i)
        loc[i] = (uint)0;

    vstore16(tmp, 0, (private uint*)loc + 1);
    vstore16(tmp, 1, (private uint*)loc + 1);
    for (int i = 0; i < 33; ++i)
        out[i] = loc[i];
}
