/* [config]
 * expect_result: pass
 * glsl_version: 1.50
 * require_extensions: GL_ARB_gpu_shader_fp64
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * equal(dvec3(-1.5lf, -1.5lf, -1.5lf), dvec3(-1.5lf, -0.5lf, 0.5lf)) => bvec3(true, false, false)
 * equal(dvec3(-1.5lf, -0.5lf, -0.5lf), dvec3(1.5lf, -1.5lf, -0.5lf)) => bvec3(false, false, true)
 * equal(dvec3(-0.5lf, -0.5lf, 0.5lf), dvec3(0.5lf, 1.5lf, -1.5lf)) => bvec3(false, false, false)
 * equal(dvec3(0.5lf, 0.5lf, 0.5lf), dvec3(-0.5lf, 0.5lf, 1.5lf)) => bvec3(false, true, false)
 * equal(dvec3(1.5lf, 1.5lf, 1.5lf), dvec3(-1.5lf, -0.5lf, 0.5lf)) => bvec3(false, false, false)
 * equal(dvec3(1.5lf, -1.5lf, -1.5lf), dvec3(1.5lf, -1.5lf, -0.5lf)) => bvec3(true, true, false)
 */
#version 150
#extension GL_ARB_gpu_shader_fp64 : require

void main()
{
  double[equal(dvec3(-1.5lf, -1.5lf, -1.5lf), dvec3(-1.5lf, -0.5lf, 0.5lf))[0] == true && equal(dvec3(-1.5lf, -1.5lf, -1.5lf), dvec3(-1.5lf, -0.5lf, 0.5lf))[1] == false && equal(dvec3(-1.5lf, -1.5lf, -1.5lf), dvec3(-1.5lf, -0.5lf, 0.5lf))[2] == false ? 1 : -1] array0;
  double[equal(dvec3(-1.5lf, -0.5lf, -0.5lf), dvec3(1.5lf, -1.5lf, -0.5lf))[0] == false && equal(dvec3(-1.5lf, -0.5lf, -0.5lf), dvec3(1.5lf, -1.5lf, -0.5lf))[1] == false && equal(dvec3(-1.5lf, -0.5lf, -0.5lf), dvec3(1.5lf, -1.5lf, -0.5lf))[2] == true ? 1 : -1] array1;
  double[equal(dvec3(-0.5lf, -0.5lf, 0.5lf), dvec3(0.5lf, 1.5lf, -1.5lf))[0] == false && equal(dvec3(-0.5lf, -0.5lf, 0.5lf), dvec3(0.5lf, 1.5lf, -1.5lf))[1] == false && equal(dvec3(-0.5lf, -0.5lf, 0.5lf), dvec3(0.5lf, 1.5lf, -1.5lf))[2] == false ? 1 : -1] array2;
  double[equal(dvec3(0.5lf, 0.5lf, 0.5lf), dvec3(-0.5lf, 0.5lf, 1.5lf))[0] == false && equal(dvec3(0.5lf, 0.5lf, 0.5lf), dvec3(-0.5lf, 0.5lf, 1.5lf))[1] == true && equal(dvec3(0.5lf, 0.5lf, 0.5lf), dvec3(-0.5lf, 0.5lf, 1.5lf))[2] == false ? 1 : -1] array3;
  double[equal(dvec3(1.5lf, 1.5lf, 1.5lf), dvec3(-1.5lf, -0.5lf, 0.5lf))[0] == false && equal(dvec3(1.5lf, 1.5lf, 1.5lf), dvec3(-1.5lf, -0.5lf, 0.5lf))[1] == false && equal(dvec3(1.5lf, 1.5lf, 1.5lf), dvec3(-1.5lf, -0.5lf, 0.5lf))[2] == false ? 1 : -1] array4;
  double[equal(dvec3(1.5lf, -1.5lf, -1.5lf), dvec3(1.5lf, -1.5lf, -0.5lf))[0] == true && equal(dvec3(1.5lf, -1.5lf, -1.5lf), dvec3(1.5lf, -1.5lf, -0.5lf))[1] == true && equal(dvec3(1.5lf, -1.5lf, -1.5lf), dvec3(1.5lf, -1.5lf, -0.5lf))[2] == false ? 1 : -1] array5;
  gl_FragColor = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length());
}
