/* [config]
 * expect_result: pass
 * glsl_version: 1.50
 * require_extensions: GL_ARB_gpu_shader_fp64
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (dvec4(-1.65lf, 1.33lf, 1.93lf, 0.76lf) - dvec4(-1.65lf, 1.33lf, 1.93lf, 0.76lf)) => dvec4(0.0lf, 0.0lf, 0.0lf, 0.0lf)
 * (dvec4(-1.65lf, 1.33lf, 1.93lf, 0.76lf) - dvec4(0.8lf, -0.15lf, -0.51lf, 0.0lf)) => dvec4(-2.45lf, 1.48lf, 2.44lf, 0.76lf)
 * (dvec4(0.8lf, -0.15lf, -0.51lf, 0.0lf) - dvec4(-1.65lf, 1.33lf, 1.93lf, 0.76lf)) => dvec4(2.45lf, -1.48lf, -2.44lf, -0.76lf)
 * (dvec4(0.8lf, -0.15lf, -0.51lf, 0.0lf) - dvec4(0.8lf, -0.15lf, -0.51lf, 0.0lf)) => dvec4(0.0lf, 0.0lf, 0.0lf, 0.0lf)
 */
#version 150
#extension GL_ARB_gpu_shader_fp64 : require

void main()
{
  double[distance((dvec4(-1.65lf, 1.33lf, 1.93lf, 0.76lf) - dvec4(-1.65lf, 1.33lf, 1.93lf, 0.76lf)), dvec4(0.0lf, 0.0lf, 0.0lf, 0.0lf)) <= 0.0lf ? 1 : -1] array0;
  double[distance((dvec4(-1.65lf, 1.33lf, 1.93lf, 0.76lf) - dvec4(0.8lf, -0.15lf, -0.51lf, 0.0lf)), dvec4(-2.45lf, 1.48lf, 2.44lf, 0.76lf)) <= 3.837199499635118e-05lf ? 1 : -1] array1;
  double[distance((dvec4(0.8lf, -0.15lf, -0.51lf, 0.0lf) - dvec4(-1.65lf, 1.33lf, 1.93lf, 0.76lf)), dvec4(2.45lf, -1.48lf, -2.44lf, -0.76lf)) <= 3.837199499635118e-05lf ? 1 : -1] array2;
  double[distance((dvec4(0.8lf, -0.15lf, -0.51lf, 0.0lf) - dvec4(0.8lf, -0.15lf, -0.51lf, 0.0lf)), dvec4(0.0lf, 0.0lf, 0.0lf, 0.0lf)) <= 0.0lf ? 1 : -1] array3;
  gl_FragColor = vec4(array0.length() + array1.length() + array2.length() + array3.length());
}
