/* [config]
 * expect_result: pass
 * glsl_version: 1.50
 * require_extensions: GL_ARB_gpu_shader_fp64
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * transpose(dmat2x3(-0.46lf, -0.45lf, 1.03lf, 1.94lf, -0.75lf, -0.5lf)) => dmat3x2(-0.46lf, 1.94lf, -0.45lf, -0.75lf, 1.03lf, -0.5lf)
 * transpose(dmat2x3(1.38lf, -1.27lf, 1.0lf, -1.08lf, 1.83lf, -0.74lf)) => dmat3x2(1.38lf, -1.08lf, -1.27lf, 1.83lf, 1.0lf, -0.74lf)
 */
#version 150
#extension GL_ARB_gpu_shader_fp64 : require

void main()
{
  double[(distance(transpose(dmat2x3(-0.46lf, -0.45lf, 1.03lf, 1.94lf, -0.75lf, -0.5lf))[0], dvec2(-0.46lf, 1.94lf)) * distance(transpose(dmat2x3(-0.46lf, -0.45lf, 1.03lf, 1.94lf, -0.75lf, -0.5lf))[0], dvec2(-0.46lf, 1.94lf))) + (distance(transpose(dmat2x3(-0.46lf, -0.45lf, 1.03lf, 1.94lf, -0.75lf, -0.5lf))[1], dvec2(-0.45lf, -0.75lf)) * distance(transpose(dmat2x3(-0.46lf, -0.45lf, 1.03lf, 1.94lf, -0.75lf, -0.5lf))[1], dvec2(-0.45lf, -0.75lf))) + (distance(transpose(dmat2x3(-0.46lf, -0.45lf, 1.03lf, 1.94lf, -0.75lf, -0.5lf))[2], dvec2(1.03lf, -0.5lf)) * distance(transpose(dmat2x3(-0.46lf, -0.45lf, 1.03lf, 1.94lf, -0.75lf, -0.5lf))[2], dvec2(1.03lf, -0.5lf))) <= 6.051100000000002e-10lf ? 1 : -1] array0;
  double[(distance(transpose(dmat2x3(1.38lf, -1.27lf, 1.0lf, -1.08lf, 1.83lf, -0.74lf))[0], dvec2(1.38lf, -1.08lf)) * distance(transpose(dmat2x3(1.38lf, -1.27lf, 1.0lf, -1.08lf, 1.83lf, -0.74lf))[0], dvec2(1.38lf, -1.08lf))) + (distance(transpose(dmat2x3(1.38lf, -1.27lf, 1.0lf, -1.08lf, 1.83lf, -0.74lf))[1], dvec2(-1.27lf, 1.83lf)) * distance(transpose(dmat2x3(1.38lf, -1.27lf, 1.0lf, -1.08lf, 1.83lf, -0.74lf))[1], dvec2(-1.27lf, 1.83lf))) + (distance(transpose(dmat2x3(1.38lf, -1.27lf, 1.0lf, -1.08lf, 1.83lf, -0.74lf))[2], dvec2(1.0lf, -0.74lf)) * distance(transpose(dmat2x3(1.38lf, -1.27lf, 1.0lf, -1.08lf, 1.83lf, -0.74lf))[2], dvec2(1.0lf, -0.74lf))) <= 9.5802e-10lf ? 1 : -1] array1;
  gl_Position = vec4(array0.length() + array1.length());
}
