/* [config]
 * expect_result: pass
 * glsl_version: 1.50
 * require_extensions: GL_ARB_gpu_shader_fp64
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * transpose(dmat3(-1.11lf, 0.13lf, 0.56lf, 1.67lf, 1.09lf, 0.95lf, -0.41lf, -0.02lf, 0.24lf)) => dmat3(-1.11lf, 1.67lf, -0.41lf, 0.13lf, 1.09lf, -0.02lf, 0.56lf, 0.95lf, 0.24lf)
 * transpose(dmat3(-1.69lf, -1.09lf, -1.53lf, -0.46lf, 1.75lf, -0.7lf, -0.18lf, 2.0lf, -1.47lf)) => dmat3(-1.69lf, -0.46lf, -0.18lf, -1.09lf, 1.75lf, 2.0lf, -1.53lf, -0.7lf, -1.47lf)
 */
#version 150
#extension GL_ARB_gpu_shader_fp64 : require

void main()
{
  double[(distance(transpose(dmat3(-1.11lf, 0.13lf, 0.56lf, 1.67lf, 1.09lf, 0.95lf, -0.41lf, -0.02lf, 0.24lf))[0], dvec3(-1.11lf, 1.67lf, -0.41lf)) * distance(transpose(dmat3(-1.11lf, 0.13lf, 0.56lf, 1.67lf, 1.09lf, 0.95lf, -0.41lf, -0.02lf, 0.24lf))[0], dvec3(-1.11lf, 1.67lf, -0.41lf))) + (distance(transpose(dmat3(-1.11lf, 0.13lf, 0.56lf, 1.67lf, 1.09lf, 0.95lf, -0.41lf, -0.02lf, 0.24lf))[1], dvec3(0.13lf, 1.09lf, -0.02lf)) * distance(transpose(dmat3(-1.11lf, 0.13lf, 0.56lf, 1.67lf, 1.09lf, 0.95lf, -0.41lf, -0.02lf, 0.24lf))[1], dvec3(0.13lf, 1.09lf, -0.02lf))) + (distance(transpose(dmat3(-1.11lf, 0.13lf, 0.56lf, 1.67lf, 1.09lf, 0.95lf, -0.41lf, -0.02lf, 0.24lf))[2], dvec3(0.56lf, 0.95lf, 0.24lf)) * distance(transpose(dmat3(-1.11lf, 0.13lf, 0.56lf, 1.67lf, 1.09lf, 0.95lf, -0.41lf, -0.02lf, 0.24lf))[2], dvec3(0.56lf, 0.95lf, 0.24lf))) <= 6.668199999999999e-10lf ? 1 : -1] array0;
  double[(distance(transpose(dmat3(-1.69lf, -1.09lf, -1.53lf, -0.46lf, 1.75lf, -0.7lf, -0.18lf, 2.0lf, -1.47lf))[0], dvec3(-1.69lf, -0.46lf, -0.18lf)) * distance(transpose(dmat3(-1.69lf, -1.09lf, -1.53lf, -0.46lf, 1.75lf, -0.7lf, -0.18lf, 2.0lf, -1.47lf))[0], dvec3(-1.69lf, -0.46lf, -0.18lf))) + (distance(transpose(dmat3(-1.69lf, -1.09lf, -1.53lf, -0.46lf, 1.75lf, -0.7lf, -0.18lf, 2.0lf, -1.47lf))[1], dvec3(-1.09lf, 1.75lf, 2.0lf)) * distance(transpose(dmat3(-1.69lf, -1.09lf, -1.53lf, -0.46lf, 1.75lf, -0.7lf, -0.18lf, 2.0lf, -1.47lf))[1], dvec3(-1.09lf, 1.75lf, 2.0lf))) + (distance(transpose(dmat3(-1.69lf, -1.09lf, -1.53lf, -0.46lf, 1.75lf, -0.7lf, -0.18lf, 2.0lf, -1.47lf))[2], dvec3(-1.53lf, -0.7lf, -1.47lf)) * distance(transpose(dmat3(-1.69lf, -1.09lf, -1.53lf, -0.46lf, 1.75lf, -0.7lf, -0.18lf, 2.0lf, -1.47lf))[2], dvec3(-1.53lf, -0.7lf, -1.47lf))) <= 1.634250000000001e-09lf ? 1 : -1] array1;
  gl_Position = vec4(array0.length() + array1.length());
}
