/* [config]
 * expect_result: pass
 * glsl_version: 4.00
 * require_extensions: GL_ARB_gpu_shader_int64
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (i64vec3(167l, 66l, 187l) % 3l) => i64vec3(2l, 0l, 1l)
 * (i64vec3(167l, 66l, 187l) % 1048576l) => i64vec3(167l, 66l, 187l)
 * (i64vec3(167l, 66l, 187l) % 4251475l) => i64vec3(167l, 66l, 187l)
 * (i64vec3(167l, 66l, 187l) % 29852643761l) => i64vec3(167l, 66l, 187l)
 */
#version 400
#extension GL_ARB_gpu_shader_int64 : require

void main()
{
  float[all(equal((i64vec3(167l, 66l, 187l) % 3l), i64vec3(2l, 0l, 1l))) ? 1 : -1] array0;
  float[all(equal((i64vec3(167l, 66l, 187l) % 1048576l), i64vec3(167l, 66l, 187l))) ? 1 : -1] array1;
  float[all(equal((i64vec3(167l, 66l, 187l) % 4251475l), i64vec3(167l, 66l, 187l))) ? 1 : -1] array2;
  float[all(equal((i64vec3(167l, 66l, 187l) % 29852643761l), i64vec3(167l, 66l, 187l))) ? 1 : -1] array3;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length());
}
