/* [config]
 * expect_result: pass
 * glsl_version: 1.20
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * faceforward(vec2(-0.1, -1.2), vec2(-0.1, -1.2), vec2(-0.1, -1.2)) => vec2(0.1, 1.2)
 * faceforward(vec2(-0.1, -1.2), vec2(-0.1, -1.2), vec2(-0.42, 0.48)) => vec2(-0.1, -1.2)
 * faceforward(vec2(-0.1, -1.2), vec2(-0.42, 0.48), vec2(-0.1, -1.2)) => vec2(-0.1, -1.2)
 * faceforward(vec2(-0.1, -1.2), vec2(-0.42, 0.48), vec2(-0.42, 0.48)) => vec2(0.1, 1.2)
 * faceforward(vec2(-0.42, 0.48), vec2(-0.1, -1.2), vec2(-0.1, -1.2)) => vec2(0.42, -0.48)
 * faceforward(vec2(-0.42, 0.48), vec2(-0.1, -1.2), vec2(-0.42, 0.48)) => vec2(-0.42, 0.48)
 * faceforward(vec2(-0.42, 0.48), vec2(-0.42, 0.48), vec2(-0.1, -1.2)) => vec2(-0.42, 0.48)
 * faceforward(vec2(-0.42, 0.48), vec2(-0.42, 0.48), vec2(-0.42, 0.48)) => vec2(0.42, -0.48)
 */
#version 120

void main()
{
  float[distance(faceforward(vec2(-0.1, -1.2), vec2(-0.1, -1.2), vec2(-0.1, -1.2)), vec2(0.1, 1.2)) <= 1.2041595e-05 ? 1 : -1] array0;
  float[distance(faceforward(vec2(-0.1, -1.2), vec2(-0.1, -1.2), vec2(-0.42, 0.48)), vec2(-0.1, -1.2)) <= 1.2041595e-05 ? 1 : -1] array1;
  float[distance(faceforward(vec2(-0.1, -1.2), vec2(-0.42, 0.48), vec2(-0.1, -1.2)), vec2(-0.1, -1.2)) <= 1.2041595e-05 ? 1 : -1] array2;
  float[distance(faceforward(vec2(-0.1, -1.2), vec2(-0.42, 0.48), vec2(-0.42, 0.48)), vec2(0.1, 1.2)) <= 1.2041595e-05 ? 1 : -1] array3;
  float[distance(faceforward(vec2(-0.42, 0.48), vec2(-0.1, -1.2), vec2(-0.1, -1.2)), vec2(0.42, -0.48)) <= 6.378087e-06 ? 1 : -1] array4;
  float[distance(faceforward(vec2(-0.42, 0.48), vec2(-0.1, -1.2), vec2(-0.42, 0.48)), vec2(-0.42, 0.48)) <= 6.378087e-06 ? 1 : -1] array5;
  float[distance(faceforward(vec2(-0.42, 0.48), vec2(-0.42, 0.48), vec2(-0.1, -1.2)), vec2(-0.42, 0.48)) <= 6.378087e-06 ? 1 : -1] array6;
  float[distance(faceforward(vec2(-0.42, 0.48), vec2(-0.42, 0.48), vec2(-0.42, 0.48)), vec2(0.42, -0.48)) <= 6.378087e-06 ? 1 : -1] array7;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length() + array6.length() + array7.length());
}
