/* [config]
 * expect_result: pass
 * glsl_version: 1.20
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * length(vec2(-0.1, -1.2)) => 1.2041595
 * length(vec2(-0.42, 0.48)) => 0.63780874
 */
#version 120

void main()
{
  float[distance(length(vec2(-0.1, -1.2)), 1.2041595) <= 1.2041595e-05 ? 1 : -1] array0;
  float[distance(length(vec2(-0.42, 0.48)), 0.63780874) <= 6.378087e-06 ? 1 : -1] array1;
  gl_FragColor = vec4(array0.length() + array1.length());
}
