/* [config]
 * expect_result: pass
 * glsl_version: 1.20
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * log(0.01) => -4.6051702
 * log(0.67333335) => -0.39551476
 * log(1.3366667) => 0.29017898
 * log(2.0) => 0.6931472
 */
#version 120

void main()
{
  float[distance(log(0.01), -4.6051702) <= 4.60517e-05 ? 1 : -1] array0;
  float[distance(log(0.67333335), -0.39551476) <= 3.9551473e-06 ? 1 : -1] array1;
  float[distance(log(1.3366667), 0.29017898) <= 2.90179e-06 ? 1 : -1] array2;
  float[distance(log(2.0), 0.6931472) <= 6.931472e-06 ? 1 : -1] array3;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length());
}
