/* [config]
 * expect_result: pass
 * glsl_version: 1.20
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * sqrt(vec2(0.0, 0.6666667)) => vec2(0.0, 0.8164966)
 * sqrt(vec2(1.3333334, 2.0)) => vec2(1.1547005, 1.4142135)
 */
#version 120

void main()
{
  float[distance(sqrt(vec2(0.0, 0.6666667)), vec2(0.0, 0.8164966)) <= 8.164966e-06 ? 1 : -1] array0;
  float[distance(sqrt(vec2(1.3333334, 2.0)), vec2(1.1547005, 1.4142135)) <= 1.8257419e-05 ? 1 : -1] array1;
  gl_Position = vec4(array0.length() + array1.length());
}
