/* [config]
 * expect_result: pass
 * glsl_version: 1.20
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * transpose(mat3x2(0.09, -1.19, 1.3, 0.08, 1.25, 1.08)) => mat2x3(0.09, 1.3, 1.25, -1.19, 0.08, 1.08)
 * transpose(mat3x2(-0.36, -0.53, -1.08, 0.88, -0.6, -1.79)) => mat2x3(-0.36, -1.08, -0.6, -0.53, 0.88, -1.79)
 */
#version 120

void main()
{
  float[pow(distance(transpose(mat3x2(0.09, -1.19, 1.3, 0.08, 1.25, 1.08))[0], vec3(0.09, 1.3, 1.25)), 2) + pow(distance(transpose(mat3x2(0.09, -1.19, 1.3, 0.08, 1.25, 1.08))[1], vec3(-1.19, 0.08, 1.08)), 2) <= 5.8495e-10 ? 1 : -1] array0;
  float[pow(distance(transpose(mat3x2(-0.36, -0.53, -1.08, 0.88, -0.6, -1.79))[0], vec3(-0.36, -1.08, -0.6)), 2) + pow(distance(transpose(mat3x2(-0.36, -0.53, -1.08, 0.88, -0.6, -1.79))[1], vec3(-0.53, 0.88, -1.79)), 2) <= 5.9154e-10 ? 1 : -1] array1;
  gl_FragColor = vec4(array0.length() + array1.length());
}
