/* [config]
 * expect_result: pass
 * glsl_version: 1.30
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * cosh(-2.0) => 3.7621956
 * cosh(-0.6666667) => 1.2305756
 * cosh(0.6666667) => 1.2305756
 * cosh(2.0) => 3.7621956
 */
#version 130

void main()
{
  float[distance(cosh(-2.0), 3.7621956) <= 0.0037621956 ? 1 : -1] array0;
  float[distance(cosh(-0.6666667), 1.2305756) <= 0.0012305756 ? 1 : -1] array1;
  float[distance(cosh(0.6666667), 1.2305756) <= 0.0012305756 ? 1 : -1] array2;
  float[distance(cosh(2.0), 3.7621956) <= 0.0037621956 ? 1 : -1] array3;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length());
}
