/* [config]
 * expect_result: pass
 * glsl_version: 1.30
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (12 | abs(~ ivec2(38, 35))) => ivec2(47, 44)
 * (12 | abs(~ ivec2(64, -9))) => ivec2(77, 12)
 * (12 | abs(~ ivec2(64, 9))) => ivec2(77, 14)
 * (-6 | abs(~ ivec2(38, 35))) => ivec2(-1, -2)
 * (-6 | abs(~ ivec2(64, -9))) => ivec2(-5, -6)
 * (-6 | abs(~ ivec2(64, 9))) => ivec2(-5, -6)
 * (76 | abs(~ ivec2(38, 35))) => ivec2(111, 108)
 * (76 | abs(~ ivec2(64, -9))) => ivec2(77, 76)
 * (76 | abs(~ ivec2(64, 9))) => ivec2(77, 78)
 * (-32 | abs(~ ivec2(38, 35))) => ivec2(-25, -28)
 * (-32 | abs(~ ivec2(64, -9))) => ivec2(-31, -24)
 * (-32 | abs(~ ivec2(64, 9))) => ivec2(-31, -22)
 * (0 | abs(~ ivec2(38, 35))) => ivec2(39, 36)
 * (0 | abs(~ ivec2(64, -9))) => ivec2(65, 8)
 * (0 | abs(~ ivec2(64, 9))) => ivec2(65, 10)
 */
#version 130

void main()
{
  float[all(equal((12 | abs(~ ivec2(38, 35))), ivec2(47, 44))) ? 1 : -1] array0;
  float[all(equal((12 | abs(~ ivec2(64, -9))), ivec2(77, 12))) ? 1 : -1] array1;
  float[all(equal((12 | abs(~ ivec2(64, 9))), ivec2(77, 14))) ? 1 : -1] array2;
  float[all(equal((-6 | abs(~ ivec2(38, 35))), ivec2(-1, -2))) ? 1 : -1] array3;
  float[all(equal((-6 | abs(~ ivec2(64, -9))), ivec2(-5, -6))) ? 1 : -1] array4;
  float[all(equal((-6 | abs(~ ivec2(64, 9))), ivec2(-5, -6))) ? 1 : -1] array5;
  float[all(equal((76 | abs(~ ivec2(38, 35))), ivec2(111, 108))) ? 1 : -1] array6;
  float[all(equal((76 | abs(~ ivec2(64, -9))), ivec2(77, 76))) ? 1 : -1] array7;
  float[all(equal((76 | abs(~ ivec2(64, 9))), ivec2(77, 78))) ? 1 : -1] array8;
  float[all(equal((-32 | abs(~ ivec2(38, 35))), ivec2(-25, -28))) ? 1 : -1] array9;
  float[all(equal((-32 | abs(~ ivec2(64, -9))), ivec2(-31, -24))) ? 1 : -1] array10;
  float[all(equal((-32 | abs(~ ivec2(64, 9))), ivec2(-31, -22))) ? 1 : -1] array11;
  float[all(equal((0 | abs(~ ivec2(38, 35))), ivec2(39, 36))) ? 1 : -1] array12;
  float[all(equal((0 | abs(~ ivec2(64, -9))), ivec2(65, 8))) ? 1 : -1] array13;
  float[all(equal((0 | abs(~ ivec2(64, 9))), ivec2(65, 10))) ? 1 : -1] array14;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length() + array6.length() + array7.length() + array8.length() + array9.length() + array10.length() + array11.length() + array12.length() + array13.length() + array14.length());
}
