/* [config]
 * expect_result: pass
 * glsl_version: 1.30
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (ivec3(-36, 32, -88) | (- abs(12))) => ivec3(-4, -12, -4)
 * (ivec3(-36, 32, -88) | (- abs(-6))) => ivec3(-2, -6, -6)
 * (ivec3(-36, 32, -88) | (- abs(76))) => ivec3(-4, -76, -68)
 * (ivec3(-36, 32, -88) | (- abs(-32))) => ivec3(-4, -32, -24)
 * (ivec3(-36, 32, -88) | (- abs(0))) => ivec3(-36, 32, -88)
 * (ivec3(36, 32, 88) | (- abs(12))) => ivec3(-12, -12, -4)
 * (ivec3(36, 32, 88) | (- abs(-6))) => ivec3(-2, -6, -6)
 * (ivec3(36, 32, 88) | (- abs(76))) => ivec3(-76, -76, -4)
 * (ivec3(36, 32, 88) | (- abs(-32))) => ivec3(-28, -32, -8)
 * (ivec3(36, 32, 88) | (- abs(0))) => ivec3(36, 32, 88)
 * (ivec3(59, 77, 68) | (- abs(12))) => ivec3(-1, -3, -12)
 * (ivec3(59, 77, 68) | (- abs(-6))) => ivec3(-5, -1, -2)
 * (ivec3(59, 77, 68) | (- abs(76))) => ivec3(-65, -3, -12)
 * (ivec3(59, 77, 68) | (- abs(-32))) => ivec3(-5, -19, -28)
 * (ivec3(59, 77, 68) | (- abs(0))) => ivec3(59, 77, 68)
 */
#version 130

void main()
{
  float[all(equal((ivec3(-36, 32, -88) | (- abs(12))), ivec3(-4, -12, -4))) ? 1 : -1] array0;
  float[all(equal((ivec3(-36, 32, -88) | (- abs(-6))), ivec3(-2, -6, -6))) ? 1 : -1] array1;
  float[all(equal((ivec3(-36, 32, -88) | (- abs(76))), ivec3(-4, -76, -68))) ? 1 : -1] array2;
  float[all(equal((ivec3(-36, 32, -88) | (- abs(-32))), ivec3(-4, -32, -24))) ? 1 : -1] array3;
  float[all(equal((ivec3(-36, 32, -88) | (- abs(0))), ivec3(-36, 32, -88))) ? 1 : -1] array4;
  float[all(equal((ivec3(36, 32, 88) | (- abs(12))), ivec3(-12, -12, -4))) ? 1 : -1] array5;
  float[all(equal((ivec3(36, 32, 88) | (- abs(-6))), ivec3(-2, -6, -6))) ? 1 : -1] array6;
  float[all(equal((ivec3(36, 32, 88) | (- abs(76))), ivec3(-76, -76, -4))) ? 1 : -1] array7;
  float[all(equal((ivec3(36, 32, 88) | (- abs(-32))), ivec3(-28, -32, -8))) ? 1 : -1] array8;
  float[all(equal((ivec3(36, 32, 88) | (- abs(0))), ivec3(36, 32, 88))) ? 1 : -1] array9;
  float[all(equal((ivec3(59, 77, 68) | (- abs(12))), ivec3(-1, -3, -12))) ? 1 : -1] array10;
  float[all(equal((ivec3(59, 77, 68) | (- abs(-6))), ivec3(-5, -1, -2))) ? 1 : -1] array11;
  float[all(equal((ivec3(59, 77, 68) | (- abs(76))), ivec3(-65, -3, -12))) ? 1 : -1] array12;
  float[all(equal((ivec3(59, 77, 68) | (- abs(-32))), ivec3(-5, -19, -28))) ? 1 : -1] array13;
  float[all(equal((ivec3(59, 77, 68) | (- abs(0))), ivec3(59, 77, 68))) ? 1 : -1] array14;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length() + array6.length() + array7.length() + array8.length() + array9.length() + array10.length() + array11.length() + array12.length() + array13.length() + array14.length());
}
