/* [config]
 * expect_result: pass
 * glsl_version: 1.30
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (12 | (- ivec3(-36, 32, -88))) => ivec3(44, -20, 92)
 * (12 | (- ivec3(36, 32, 88))) => ivec3(-36, -20, -84)
 * (12 | (- ivec3(59, 77, 68))) => ivec3(-51, -65, -68)
 * (-6 | (- ivec3(-36, 32, -88))) => ivec3(-2, -6, -6)
 * (-6 | (- ivec3(36, 32, 88))) => ivec3(-2, -6, -6)
 * (-6 | (- ivec3(59, 77, 68))) => ivec3(-1, -5, -2)
 * (76 | (- ivec3(-36, 32, -88))) => ivec3(108, -20, 92)
 * (76 | (- ivec3(36, 32, 88))) => ivec3(-36, -20, -20)
 * (76 | (- ivec3(59, 77, 68))) => ivec3(-51, -1, -4)
 * (-32 | (- ivec3(-36, 32, -88))) => ivec3(-28, -32, -8)
 * (-32 | (- ivec3(36, 32, 88))) => ivec3(-4, -32, -24)
 * (-32 | (- ivec3(59, 77, 68))) => ivec3(-27, -13, -4)
 * (0 | (- ivec3(-36, 32, -88))) => ivec3(36, -32, 88)
 * (0 | (- ivec3(36, 32, 88))) => ivec3(-36, -32, -88)
 * (0 | (- ivec3(59, 77, 68))) => ivec3(-59, -77, -68)
 */
#version 130

void main()
{
  float[all(equal((12 | (- ivec3(-36, 32, -88))), ivec3(44, -20, 92))) ? 1 : -1] array0;
  float[all(equal((12 | (- ivec3(36, 32, 88))), ivec3(-36, -20, -84))) ? 1 : -1] array1;
  float[all(equal((12 | (- ivec3(59, 77, 68))), ivec3(-51, -65, -68))) ? 1 : -1] array2;
  float[all(equal((-6 | (- ivec3(-36, 32, -88))), ivec3(-2, -6, -6))) ? 1 : -1] array3;
  float[all(equal((-6 | (- ivec3(36, 32, 88))), ivec3(-2, -6, -6))) ? 1 : -1] array4;
  float[all(equal((-6 | (- ivec3(59, 77, 68))), ivec3(-1, -5, -2))) ? 1 : -1] array5;
  float[all(equal((76 | (- ivec3(-36, 32, -88))), ivec3(108, -20, 92))) ? 1 : -1] array6;
  float[all(equal((76 | (- ivec3(36, 32, 88))), ivec3(-36, -20, -20))) ? 1 : -1] array7;
  float[all(equal((76 | (- ivec3(59, 77, 68))), ivec3(-51, -1, -4))) ? 1 : -1] array8;
  float[all(equal((-32 | (- ivec3(-36, 32, -88))), ivec3(-28, -32, -8))) ? 1 : -1] array9;
  float[all(equal((-32 | (- ivec3(36, 32, 88))), ivec3(-4, -32, -24))) ? 1 : -1] array10;
  float[all(equal((-32 | (- ivec3(59, 77, 68))), ivec3(-27, -13, -4))) ? 1 : -1] array11;
  float[all(equal((0 | (- ivec3(-36, 32, -88))), ivec3(36, -32, 88))) ? 1 : -1] array12;
  float[all(equal((0 | (- ivec3(36, 32, 88))), ivec3(-36, -32, -88))) ? 1 : -1] array13;
  float[all(equal((0 | (- ivec3(59, 77, 68))), ivec3(-59, -77, -68))) ? 1 : -1] array14;
  gl_FragColor = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length() + array6.length() + array7.length() + array8.length() + array9.length() + array10.length() + array11.length() + array12.length() + array13.length() + array14.length());
}
