/* [config]
 * expect_result: pass
 * glsl_version: 1.30
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (ivec3(-36, 32, -88) | (~ 12)) => ivec3(-1, -13, -5)
 * (ivec3(-36, 32, -88) | (~ -6)) => ivec3(-35, 37, -83)
 * (ivec3(-36, 32, -88) | (~ 76)) => ivec3(-1, -77, -69)
 * (ivec3(-36, 32, -88) | (~ -32)) => ivec3(-33, 63, -65)
 * (ivec3(-36, 32, -88) | (~ 0)) => ivec3(-1, -1, -1)
 * (ivec3(36, 32, 88) | (~ 12)) => ivec3(-9, -13, -5)
 * (ivec3(36, 32, 88) | (~ -6)) => ivec3(37, 37, 93)
 * (ivec3(36, 32, 88) | (~ 76)) => ivec3(-73, -77, -5)
 * (ivec3(36, 32, 88) | (~ -32)) => ivec3(63, 63, 95)
 * (ivec3(36, 32, 88) | (~ 0)) => ivec3(-1, -1, -1)
 * (ivec3(59, 77, 68) | (~ 12)) => ivec3(-5, -1, -9)
 * (ivec3(59, 77, 68) | (~ -6)) => ivec3(63, 77, 69)
 * (ivec3(59, 77, 68) | (~ 76)) => ivec3(-69, -1, -9)
 * (ivec3(59, 77, 68) | (~ -32)) => ivec3(63, 95, 95)
 * (ivec3(59, 77, 68) | (~ 0)) => ivec3(-1, -1, -1)
 */
#version 130

void main()
{
  float[all(equal((ivec3(-36, 32, -88) | (~ 12)), ivec3(-1, -13, -5))) ? 1 : -1] array0;
  float[all(equal((ivec3(-36, 32, -88) | (~ -6)), ivec3(-35, 37, -83))) ? 1 : -1] array1;
  float[all(equal((ivec3(-36, 32, -88) | (~ 76)), ivec3(-1, -77, -69))) ? 1 : -1] array2;
  float[all(equal((ivec3(-36, 32, -88) | (~ -32)), ivec3(-33, 63, -65))) ? 1 : -1] array3;
  float[all(equal((ivec3(-36, 32, -88) | (~ 0)), ivec3(-1, -1, -1))) ? 1 : -1] array4;
  float[all(equal((ivec3(36, 32, 88) | (~ 12)), ivec3(-9, -13, -5))) ? 1 : -1] array5;
  float[all(equal((ivec3(36, 32, 88) | (~ -6)), ivec3(37, 37, 93))) ? 1 : -1] array6;
  float[all(equal((ivec3(36, 32, 88) | (~ 76)), ivec3(-73, -77, -5))) ? 1 : -1] array7;
  float[all(equal((ivec3(36, 32, 88) | (~ -32)), ivec3(63, 63, 95))) ? 1 : -1] array8;
  float[all(equal((ivec3(36, 32, 88) | (~ 0)), ivec3(-1, -1, -1))) ? 1 : -1] array9;
  float[all(equal((ivec3(59, 77, 68) | (~ 12)), ivec3(-5, -1, -9))) ? 1 : -1] array10;
  float[all(equal((ivec3(59, 77, 68) | (~ -6)), ivec3(63, 77, 69))) ? 1 : -1] array11;
  float[all(equal((ivec3(59, 77, 68) | (~ 76)), ivec3(-69, -1, -9))) ? 1 : -1] array12;
  float[all(equal((ivec3(59, 77, 68) | (~ -32)), ivec3(63, 95, 95))) ? 1 : -1] array13;
  float[all(equal((ivec3(59, 77, 68) | (~ 0)), ivec3(-1, -1, -1))) ? 1 : -1] array14;
  gl_FragColor = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length() + array6.length() + array7.length() + array8.length() + array9.length() + array10.length() + array11.length() + array12.length() + array13.length() + array14.length());
}
