/* [config]
 * expect_result: pass
 * glsl_version: 1.30
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (ivec2(38, 35) ^ abs(~ 12)) => ivec2(43, 46)
 * (ivec2(38, 35) ^ abs(~ -6)) => ivec2(35, 38)
 * (ivec2(38, 35) ^ abs(~ 76)) => ivec2(107, 110)
 * (ivec2(38, 35) ^ abs(~ -32)) => ivec2(57, 60)
 * (ivec2(38, 35) ^ abs(~ 0)) => ivec2(39, 34)
 * (ivec2(64, -9) ^ abs(~ 12)) => ivec2(77, -6)
 * (ivec2(64, -9) ^ abs(~ -6)) => ivec2(69, -14)
 * (ivec2(64, -9) ^ abs(~ 76)) => ivec2(13, -70)
 * (ivec2(64, -9) ^ abs(~ -32)) => ivec2(95, -24)
 * (ivec2(64, -9) ^ abs(~ 0)) => ivec2(65, -10)
 * (ivec2(64, 9) ^ abs(~ 12)) => ivec2(77, 4)
 * (ivec2(64, 9) ^ abs(~ -6)) => ivec2(69, 12)
 * (ivec2(64, 9) ^ abs(~ 76)) => ivec2(13, 68)
 * (ivec2(64, 9) ^ abs(~ -32)) => ivec2(95, 22)
 * (ivec2(64, 9) ^ abs(~ 0)) => ivec2(65, 8)
 */
#version 130

void main()
{
  float[all(equal((ivec2(38, 35) ^ abs(~ 12)), ivec2(43, 46))) ? 1 : -1] array0;
  float[all(equal((ivec2(38, 35) ^ abs(~ -6)), ivec2(35, 38))) ? 1 : -1] array1;
  float[all(equal((ivec2(38, 35) ^ abs(~ 76)), ivec2(107, 110))) ? 1 : -1] array2;
  float[all(equal((ivec2(38, 35) ^ abs(~ -32)), ivec2(57, 60))) ? 1 : -1] array3;
  float[all(equal((ivec2(38, 35) ^ abs(~ 0)), ivec2(39, 34))) ? 1 : -1] array4;
  float[all(equal((ivec2(64, -9) ^ abs(~ 12)), ivec2(77, -6))) ? 1 : -1] array5;
  float[all(equal((ivec2(64, -9) ^ abs(~ -6)), ivec2(69, -14))) ? 1 : -1] array6;
  float[all(equal((ivec2(64, -9) ^ abs(~ 76)), ivec2(13, -70))) ? 1 : -1] array7;
  float[all(equal((ivec2(64, -9) ^ abs(~ -32)), ivec2(95, -24))) ? 1 : -1] array8;
  float[all(equal((ivec2(64, -9) ^ abs(~ 0)), ivec2(65, -10))) ? 1 : -1] array9;
  float[all(equal((ivec2(64, 9) ^ abs(~ 12)), ivec2(77, 4))) ? 1 : -1] array10;
  float[all(equal((ivec2(64, 9) ^ abs(~ -6)), ivec2(69, 12))) ? 1 : -1] array11;
  float[all(equal((ivec2(64, 9) ^ abs(~ 76)), ivec2(13, 68))) ? 1 : -1] array12;
  float[all(equal((ivec2(64, 9) ^ abs(~ -32)), ivec2(95, 22))) ? 1 : -1] array13;
  float[all(equal((ivec2(64, 9) ^ abs(~ 0)), ivec2(65, 8))) ? 1 : -1] array14;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length() + array6.length() + array7.length() + array8.length() + array9.length() + array10.length() + array11.length() + array12.length() + array13.length() + array14.length());
}
