/* [config]
 * expect_result: pass
 * glsl_version: 1.50
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * acosh(vec2(1.0, 1.0)) => vec2(0.0, 0.0)
 * acosh(vec2(1.1, 2.0)) => vec2(0.44356832, 1.316958)
 * acosh(vec2(11.0, 10000000000.0)) => vec2(3.08897, 23.718998)
 */
#version 150

void main()
{
  float[distance(acosh(vec2(1.0, 1.0)), vec2(0.0, 0.0)) <= 0.00014142135 ? 1 : -1] array0;
  float[distance(acosh(vec2(1.1, 2.0)), vec2(0.44356832, 1.316958)) <= 0.0013896514 ? 1 : -1] array1;
  float[distance(acosh(vec2(11.0, 10000000000.0)), vec2(3.08897, 23.718998)) <= 0.023919294 ? 1 : -1] array2;
  gl_Position = vec4(array0.length() + array1.length() + array2.length());
}
