/* [config]
 * expect_result: pass
 * glsl_version: 1.50
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * ceil(vec2(-2.0, -0.6666667)) => vec2(-2.0, -0.0)
 * ceil(vec2(0.6666667, 2.0)) => vec2(1.0, 2.0)
 */
#version 150

void main()
{
  float[distance(ceil(vec2(-2.0, -0.6666667)), vec2(-2.0, -0.0)) <= 2e-05 ? 1 : -1] array0;
  float[distance(ceil(vec2(0.6666667, 2.0)), vec2(1.0, 2.0)) <= 2.236068e-05 ? 1 : -1] array1;
  gl_Position = vec4(array0.length() + array1.length());
}
