/* [config]
 * expect_result: pass
 * glsl_version: 1.50
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * clamp(uvec4(0u, 0u, 0u, 0u), uvec4(0u, 0u, 0u, 0u), uvec4(0u, 1u, 2u, 5u)) => uvec4(0u, 0u, 0u, 0u)
 * clamp(uvec4(0u, 0u, 0u, 0u), uvec4(0u, 1u, 1u, 1u), uvec4(34u, 1u, 2u, 5u)) => uvec4(0u, 1u, 1u, 1u)
 * clamp(uvec4(0u, 0u, 0u, 0u), uvec4(1u, 2u, 2u, 2u), uvec4(34u, 2u, 5u, 34u)) => uvec4(1u, 2u, 2u, 2u)
 * clamp(uvec4(0u, 0u, 0u, 1u), uvec4(5u, 5u, 34u, 0u), uvec4(5u, 34u, 34u, 0u)) => uvec4(5u, 5u, 34u, 0u)
 * clamp(uvec4(1u, 1u, 1u, 1u), uvec4(0u, 0u, 0u, 0u), uvec4(1u, 2u, 5u, 34u)) => uvec4(1u, 1u, 1u, 1u)
 * clamp(uvec4(1u, 1u, 1u, 1u), uvec4(1u, 1u, 1u, 1u), uvec4(1u, 2u, 5u, 34u)) => uvec4(1u, 1u, 1u, 1u)
 * clamp(uvec4(1u, 1u, 1u, 1u), uvec4(2u, 2u, 2u, 5u), uvec4(2u, 5u, 34u, 5u)) => uvec4(2u, 2u, 2u, 5u)
 * clamp(uvec4(1u, 1u, 2u, 2u), uvec4(5u, 34u, 0u, 0u), uvec4(34u, 34u, 0u, 1u)) => uvec4(5u, 34u, 0u, 1u)
 * clamp(uvec4(2u, 2u, 2u, 2u), uvec4(0u, 0u, 0u, 1u), uvec4(2u, 5u, 34u, 1u)) => uvec4(2u, 2u, 2u, 1u)
 * clamp(uvec4(2u, 2u, 2u, 2u), uvec4(1u, 1u, 1u, 2u), uvec4(2u, 5u, 34u, 2u)) => uvec4(2u, 2u, 2u, 2u)
 * clamp(uvec4(2u, 2u, 2u, 2u), uvec4(2u, 2u, 5u, 5u), uvec4(5u, 34u, 5u, 34u)) => uvec4(2u, 2u, 5u, 5u)
 * clamp(uvec4(2u, 5u, 5u, 5u), uvec4(34u, 0u, 0u, 0u), uvec4(34u, 0u, 1u, 2u)) => uvec4(34u, 0u, 1u, 2u)
 * clamp(uvec4(5u, 5u, 5u, 5u), uvec4(0u, 0u, 1u, 1u), uvec4(5u, 34u, 1u, 2u)) => uvec4(5u, 5u, 1u, 2u)
 * clamp(uvec4(5u, 5u, 5u, 5u), uvec4(1u, 1u, 2u, 2u), uvec4(5u, 34u, 2u, 5u)) => uvec4(5u, 5u, 2u, 5u)
 * clamp(uvec4(5u, 5u, 5u, 5u), uvec4(2u, 5u, 5u, 34u), uvec4(34u, 5u, 34u, 34u)) => uvec4(5u, 5u, 5u, 34u)
 * clamp(uvec4(34u, 34u, 34u, 34u), uvec4(0u, 0u, 0u, 0u), uvec4(0u, 1u, 2u, 5u)) => uvec4(0u, 1u, 2u, 5u)
 * clamp(uvec4(34u, 34u, 34u, 34u), uvec4(0u, 1u, 1u, 1u), uvec4(34u, 1u, 2u, 5u)) => uvec4(34u, 1u, 2u, 5u)
 * clamp(uvec4(34u, 34u, 34u, 34u), uvec4(1u, 2u, 2u, 2u), uvec4(34u, 2u, 5u, 34u)) => uvec4(34u, 2u, 5u, 34u)
 * clamp(uvec4(34u, 34u, 34u, 0u), uvec4(5u, 5u, 34u, 0u), uvec4(5u, 34u, 34u, 0u)) => uvec4(5u, 34u, 34u, 0u)
 */
#version 150

void main()
{
  float[all(equal(clamp(uvec4(0u, 0u, 0u, 0u), uvec4(0u, 0u, 0u, 0u), uvec4(0u, 1u, 2u, 5u)), uvec4(0u, 0u, 0u, 0u))) ? 1 : -1] array0;
  float[all(equal(clamp(uvec4(0u, 0u, 0u, 0u), uvec4(0u, 1u, 1u, 1u), uvec4(34u, 1u, 2u, 5u)), uvec4(0u, 1u, 1u, 1u))) ? 1 : -1] array1;
  float[all(equal(clamp(uvec4(0u, 0u, 0u, 0u), uvec4(1u, 2u, 2u, 2u), uvec4(34u, 2u, 5u, 34u)), uvec4(1u, 2u, 2u, 2u))) ? 1 : -1] array2;
  float[all(equal(clamp(uvec4(0u, 0u, 0u, 1u), uvec4(5u, 5u, 34u, 0u), uvec4(5u, 34u, 34u, 0u)), uvec4(5u, 5u, 34u, 0u))) ? 1 : -1] array3;
  float[all(equal(clamp(uvec4(1u, 1u, 1u, 1u), uvec4(0u, 0u, 0u, 0u), uvec4(1u, 2u, 5u, 34u)), uvec4(1u, 1u, 1u, 1u))) ? 1 : -1] array4;
  float[all(equal(clamp(uvec4(1u, 1u, 1u, 1u), uvec4(1u, 1u, 1u, 1u), uvec4(1u, 2u, 5u, 34u)), uvec4(1u, 1u, 1u, 1u))) ? 1 : -1] array5;
  float[all(equal(clamp(uvec4(1u, 1u, 1u, 1u), uvec4(2u, 2u, 2u, 5u), uvec4(2u, 5u, 34u, 5u)), uvec4(2u, 2u, 2u, 5u))) ? 1 : -1] array6;
  float[all(equal(clamp(uvec4(1u, 1u, 2u, 2u), uvec4(5u, 34u, 0u, 0u), uvec4(34u, 34u, 0u, 1u)), uvec4(5u, 34u, 0u, 1u))) ? 1 : -1] array7;
  float[all(equal(clamp(uvec4(2u, 2u, 2u, 2u), uvec4(0u, 0u, 0u, 1u), uvec4(2u, 5u, 34u, 1u)), uvec4(2u, 2u, 2u, 1u))) ? 1 : -1] array8;
  float[all(equal(clamp(uvec4(2u, 2u, 2u, 2u), uvec4(1u, 1u, 1u, 2u), uvec4(2u, 5u, 34u, 2u)), uvec4(2u, 2u, 2u, 2u))) ? 1 : -1] array9;
  float[all(equal(clamp(uvec4(2u, 2u, 2u, 2u), uvec4(2u, 2u, 5u, 5u), uvec4(5u, 34u, 5u, 34u)), uvec4(2u, 2u, 5u, 5u))) ? 1 : -1] array10;
  float[all(equal(clamp(uvec4(2u, 5u, 5u, 5u), uvec4(34u, 0u, 0u, 0u), uvec4(34u, 0u, 1u, 2u)), uvec4(34u, 0u, 1u, 2u))) ? 1 : -1] array11;
  float[all(equal(clamp(uvec4(5u, 5u, 5u, 5u), uvec4(0u, 0u, 1u, 1u), uvec4(5u, 34u, 1u, 2u)), uvec4(5u, 5u, 1u, 2u))) ? 1 : -1] array12;
  float[all(equal(clamp(uvec4(5u, 5u, 5u, 5u), uvec4(1u, 1u, 2u, 2u), uvec4(5u, 34u, 2u, 5u)), uvec4(5u, 5u, 2u, 5u))) ? 1 : -1] array13;
  float[all(equal(clamp(uvec4(5u, 5u, 5u, 5u), uvec4(2u, 5u, 5u, 34u), uvec4(34u, 5u, 34u, 34u)), uvec4(5u, 5u, 5u, 34u))) ? 1 : -1] array14;
  float[all(equal(clamp(uvec4(34u, 34u, 34u, 34u), uvec4(0u, 0u, 0u, 0u), uvec4(0u, 1u, 2u, 5u)), uvec4(0u, 1u, 2u, 5u))) ? 1 : -1] array15;
  float[all(equal(clamp(uvec4(34u, 34u, 34u, 34u), uvec4(0u, 1u, 1u, 1u), uvec4(34u, 1u, 2u, 5u)), uvec4(34u, 1u, 2u, 5u))) ? 1 : -1] array16;
  float[all(equal(clamp(uvec4(34u, 34u, 34u, 34u), uvec4(1u, 2u, 2u, 2u), uvec4(34u, 2u, 5u, 34u)), uvec4(34u, 2u, 5u, 34u))) ? 1 : -1] array17;
  float[all(equal(clamp(uvec4(34u, 34u, 34u, 0u), uvec4(5u, 5u, 34u, 0u), uvec4(5u, 34u, 34u, 0u)), uvec4(5u, 34u, 34u, 0u))) ? 1 : -1] array18;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length() + array6.length() + array7.length() + array8.length() + array9.length() + array10.length() + array11.length() + array12.length() + array13.length() + array14.length() + array15.length() + array16.length() + array17.length() + array18.length());
}
