/* [config]
 * expect_result: pass
 * glsl_version: 1.50
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * equal(uvec4(0u, 0u, 0u, 0u), uvec4(0u, 1u, 2u, 5u)) => bvec4(true, false, false, false)
 * equal(uvec4(0u, 1u, 1u, 1u), uvec4(34u, 0u, 1u, 2u)) => bvec4(false, false, true, false)
 * equal(uvec4(1u, 1u, 2u, 2u), uvec4(5u, 34u, 0u, 1u)) => bvec4(false, false, false, false)
 * equal(uvec4(2u, 2u, 2u, 5u), uvec4(2u, 5u, 34u, 0u)) => bvec4(true, false, false, false)
 * equal(uvec4(5u, 5u, 5u, 5u), uvec4(1u, 2u, 5u, 34u)) => bvec4(false, false, true, false)
 * equal(uvec4(34u, 34u, 34u, 34u), uvec4(0u, 1u, 2u, 5u)) => bvec4(false, false, false, false)
 * equal(uvec4(34u, 0u, 0u, 0u), uvec4(34u, 0u, 1u, 2u)) => bvec4(true, true, false, false)
 */
#version 150

void main()
{
  float[equal(uvec4(0u, 0u, 0u, 0u), uvec4(0u, 1u, 2u, 5u))[0] == true && equal(uvec4(0u, 0u, 0u, 0u), uvec4(0u, 1u, 2u, 5u))[1] == false && equal(uvec4(0u, 0u, 0u, 0u), uvec4(0u, 1u, 2u, 5u))[2] == false && equal(uvec4(0u, 0u, 0u, 0u), uvec4(0u, 1u, 2u, 5u))[3] == false ? 1 : -1] array0;
  float[equal(uvec4(0u, 1u, 1u, 1u), uvec4(34u, 0u, 1u, 2u))[0] == false && equal(uvec4(0u, 1u, 1u, 1u), uvec4(34u, 0u, 1u, 2u))[1] == false && equal(uvec4(0u, 1u, 1u, 1u), uvec4(34u, 0u, 1u, 2u))[2] == true && equal(uvec4(0u, 1u, 1u, 1u), uvec4(34u, 0u, 1u, 2u))[3] == false ? 1 : -1] array1;
  float[equal(uvec4(1u, 1u, 2u, 2u), uvec4(5u, 34u, 0u, 1u))[0] == false && equal(uvec4(1u, 1u, 2u, 2u), uvec4(5u, 34u, 0u, 1u))[1] == false && equal(uvec4(1u, 1u, 2u, 2u), uvec4(5u, 34u, 0u, 1u))[2] == false && equal(uvec4(1u, 1u, 2u, 2u), uvec4(5u, 34u, 0u, 1u))[3] == false ? 1 : -1] array2;
  float[equal(uvec4(2u, 2u, 2u, 5u), uvec4(2u, 5u, 34u, 0u))[0] == true && equal(uvec4(2u, 2u, 2u, 5u), uvec4(2u, 5u, 34u, 0u))[1] == false && equal(uvec4(2u, 2u, 2u, 5u), uvec4(2u, 5u, 34u, 0u))[2] == false && equal(uvec4(2u, 2u, 2u, 5u), uvec4(2u, 5u, 34u, 0u))[3] == false ? 1 : -1] array3;
  float[equal(uvec4(5u, 5u, 5u, 5u), uvec4(1u, 2u, 5u, 34u))[0] == false && equal(uvec4(5u, 5u, 5u, 5u), uvec4(1u, 2u, 5u, 34u))[1] == false && equal(uvec4(5u, 5u, 5u, 5u), uvec4(1u, 2u, 5u, 34u))[2] == true && equal(uvec4(5u, 5u, 5u, 5u), uvec4(1u, 2u, 5u, 34u))[3] == false ? 1 : -1] array4;
  float[equal(uvec4(34u, 34u, 34u, 34u), uvec4(0u, 1u, 2u, 5u))[0] == false && equal(uvec4(34u, 34u, 34u, 34u), uvec4(0u, 1u, 2u, 5u))[1] == false && equal(uvec4(34u, 34u, 34u, 34u), uvec4(0u, 1u, 2u, 5u))[2] == false && equal(uvec4(34u, 34u, 34u, 34u), uvec4(0u, 1u, 2u, 5u))[3] == false ? 1 : -1] array5;
  float[equal(uvec4(34u, 0u, 0u, 0u), uvec4(34u, 0u, 1u, 2u))[0] == true && equal(uvec4(34u, 0u, 0u, 0u), uvec4(34u, 0u, 1u, 2u))[1] == true && equal(uvec4(34u, 0u, 0u, 0u), uvec4(34u, 0u, 1u, 2u))[2] == false && equal(uvec4(34u, 0u, 0u, 0u), uvec4(34u, 0u, 1u, 2u))[3] == false ? 1 : -1] array6;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length() + array6.length());
}
