/* [config]
 * expect_result: pass
 * glsl_version: 1.50
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * max(-5, -5) => -5
 * max(-5, -2) => -2
 * max(-5, -1) => -1
 * max(-5, 0) => 0
 * max(-5, 1) => 1
 * max(-5, 2) => 2
 * max(-5, 5) => 5
 * max(-2, -5) => -2
 * max(-2, -2) => -2
 * max(-2, -1) => -1
 * max(-2, 0) => 0
 * max(-2, 1) => 1
 * max(-2, 2) => 2
 * max(-2, 5) => 5
 * max(-1, -5) => -1
 * max(-1, -2) => -1
 * max(-1, -1) => -1
 * max(-1, 0) => 0
 * max(-1, 1) => 1
 * max(-1, 2) => 2
 * max(-1, 5) => 5
 * max(0, -5) => 0
 * max(0, -2) => 0
 * max(0, -1) => 0
 * max(0, 0) => 0
 * max(0, 1) => 1
 * max(0, 2) => 2
 * max(0, 5) => 5
 * max(1, -5) => 1
 * max(1, -2) => 1
 * max(1, -1) => 1
 * max(1, 0) => 1
 * max(1, 1) => 1
 * max(1, 2) => 2
 * max(1, 5) => 5
 * max(2, -5) => 2
 * max(2, -2) => 2
 * max(2, -1) => 2
 * max(2, 0) => 2
 * max(2, 1) => 2
 * max(2, 2) => 2
 * max(2, 5) => 5
 * max(5, -5) => 5
 * max(5, -2) => 5
 * max(5, -1) => 5
 * max(5, 0) => 5
 * max(5, 1) => 5
 * max(5, 2) => 5
 * max(5, 5) => 5
 */
#version 150

void main()
{
  float[max(-5, -5) == -5 ? 1 : -1] array0;
  float[max(-5, -2) == -2 ? 1 : -1] array1;
  float[max(-5, -1) == -1 ? 1 : -1] array2;
  float[max(-5, 0) == 0 ? 1 : -1] array3;
  float[max(-5, 1) == 1 ? 1 : -1] array4;
  float[max(-5, 2) == 2 ? 1 : -1] array5;
  float[max(-5, 5) == 5 ? 1 : -1] array6;
  float[max(-2, -5) == -2 ? 1 : -1] array7;
  float[max(-2, -2) == -2 ? 1 : -1] array8;
  float[max(-2, -1) == -1 ? 1 : -1] array9;
  float[max(-2, 0) == 0 ? 1 : -1] array10;
  float[max(-2, 1) == 1 ? 1 : -1] array11;
  float[max(-2, 2) == 2 ? 1 : -1] array12;
  float[max(-2, 5) == 5 ? 1 : -1] array13;
  float[max(-1, -5) == -1 ? 1 : -1] array14;
  float[max(-1, -2) == -1 ? 1 : -1] array15;
  float[max(-1, -1) == -1 ? 1 : -1] array16;
  float[max(-1, 0) == 0 ? 1 : -1] array17;
  float[max(-1, 1) == 1 ? 1 : -1] array18;
  float[max(-1, 2) == 2 ? 1 : -1] array19;
  float[max(-1, 5) == 5 ? 1 : -1] array20;
  float[max(0, -5) == 0 ? 1 : -1] array21;
  float[max(0, -2) == 0 ? 1 : -1] array22;
  float[max(0, -1) == 0 ? 1 : -1] array23;
  float[max(0, 0) == 0 ? 1 : -1] array24;
  float[max(0, 1) == 1 ? 1 : -1] array25;
  float[max(0, 2) == 2 ? 1 : -1] array26;
  float[max(0, 5) == 5 ? 1 : -1] array27;
  float[max(1, -5) == 1 ? 1 : -1] array28;
  float[max(1, -2) == 1 ? 1 : -1] array29;
  float[max(1, -1) == 1 ? 1 : -1] array30;
  float[max(1, 0) == 1 ? 1 : -1] array31;
  float[max(1, 1) == 1 ? 1 : -1] array32;
  float[max(1, 2) == 2 ? 1 : -1] array33;
  float[max(1, 5) == 5 ? 1 : -1] array34;
  float[max(2, -5) == 2 ? 1 : -1] array35;
  float[max(2, -2) == 2 ? 1 : -1] array36;
  float[max(2, -1) == 2 ? 1 : -1] array37;
  float[max(2, 0) == 2 ? 1 : -1] array38;
  float[max(2, 1) == 2 ? 1 : -1] array39;
  float[max(2, 2) == 2 ? 1 : -1] array40;
  float[max(2, 5) == 5 ? 1 : -1] array41;
  float[max(5, -5) == 5 ? 1 : -1] array42;
  float[max(5, -2) == 5 ? 1 : -1] array43;
  float[max(5, -1) == 5 ? 1 : -1] array44;
  float[max(5, 0) == 5 ? 1 : -1] array45;
  float[max(5, 1) == 5 ? 1 : -1] array46;
  float[max(5, 2) == 5 ? 1 : -1] array47;
  float[max(5, 5) == 5 ? 1 : -1] array48;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length() + array6.length() + array7.length() + array8.length() + array9.length() + array10.length() + array11.length() + array12.length() + array13.length() + array14.length() + array15.length() + array16.length() + array17.length() + array18.length() + array19.length() + array20.length() + array21.length() + array22.length() + array23.length() + array24.length() + array25.length() + array26.length() + array27.length() + array28.length() + array29.length() + array30.length() + array31.length() + array32.length() + array33.length() + array34.length() + array35.length() + array36.length() + array37.length() + array38.length() + array39.length() + array40.length() + array41.length() + array42.length() + array43.length() + array44.length() + array45.length() + array46.length() + array47.length() + array48.length());
}
