/* [config]
 * expect_result: pass
 * glsl_version: 1.50
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (uvec4(66u, 72u, 87u, 75u) + uvec4(66u, 72u, 87u, 75u)) => uvec4(132u, 144u, 174u, 150u)
 * (uvec4(66u, 72u, 87u, 75u) + uvec4(24u, 40u, 23u, 74u)) => uvec4(90u, 112u, 110u, 149u)
 * (uvec4(24u, 40u, 23u, 74u) + uvec4(66u, 72u, 87u, 75u)) => uvec4(90u, 112u, 110u, 149u)
 * (uvec4(24u, 40u, 23u, 74u) + uvec4(24u, 40u, 23u, 74u)) => uvec4(48u, 80u, 46u, 148u)
 */
#version 150

void main()
{
  float[all(equal((uvec4(66u, 72u, 87u, 75u) + uvec4(66u, 72u, 87u, 75u)), uvec4(132u, 144u, 174u, 150u))) ? 1 : -1] array0;
  float[all(equal((uvec4(66u, 72u, 87u, 75u) + uvec4(24u, 40u, 23u, 74u)), uvec4(90u, 112u, 110u, 149u))) ? 1 : -1] array1;
  float[all(equal((uvec4(24u, 40u, 23u, 74u) + uvec4(66u, 72u, 87u, 75u)), uvec4(90u, 112u, 110u, 149u))) ? 1 : -1] array2;
  float[all(equal((uvec4(24u, 40u, 23u, 74u) + uvec4(24u, 40u, 23u, 74u)), uvec4(48u, 80u, 46u, 148u))) ? 1 : -1] array3;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length());
}
