/* [config]
 * expect_result: pass
 * glsl_version: 1.50
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (12 & (~ 12)) => 0
 * (12 & (~ -6)) => 4
 * (12 & (~ 76)) => 0
 * (12 & (~ -32)) => 12
 * (12 & (~ 0)) => 12
 * (-6 & (~ 12)) => -14
 * (-6 & (~ -6)) => 0
 * (-6 & (~ 76)) => -78
 * (-6 & (~ -32)) => 26
 * (-6 & (~ 0)) => -6
 * (76 & (~ 12)) => 64
 * (76 & (~ -6)) => 4
 * (76 & (~ 76)) => 0
 * (76 & (~ -32)) => 12
 * (76 & (~ 0)) => 76
 * (-32 & (~ 12)) => -32
 * (-32 & (~ -6)) => 0
 * (-32 & (~ 76)) => -96
 * (-32 & (~ -32)) => 0
 * (-32 & (~ 0)) => -32
 * (0 & (~ 12)) => 0
 * (0 & (~ -6)) => 0
 * (0 & (~ 76)) => 0
 * (0 & (~ -32)) => 0
 * (0 & (~ 0)) => 0
 */
#version 150

void main()
{
  float[(12 & (~ 12)) == 0 ? 1 : -1] array0;
  float[(12 & (~ -6)) == 4 ? 1 : -1] array1;
  float[(12 & (~ 76)) == 0 ? 1 : -1] array2;
  float[(12 & (~ -32)) == 12 ? 1 : -1] array3;
  float[(12 & (~ 0)) == 12 ? 1 : -1] array4;
  float[(-6 & (~ 12)) == -14 ? 1 : -1] array5;
  float[(-6 & (~ -6)) == 0 ? 1 : -1] array6;
  float[(-6 & (~ 76)) == -78 ? 1 : -1] array7;
  float[(-6 & (~ -32)) == 26 ? 1 : -1] array8;
  float[(-6 & (~ 0)) == -6 ? 1 : -1] array9;
  float[(76 & (~ 12)) == 64 ? 1 : -1] array10;
  float[(76 & (~ -6)) == 4 ? 1 : -1] array11;
  float[(76 & (~ 76)) == 0 ? 1 : -1] array12;
  float[(76 & (~ -32)) == 12 ? 1 : -1] array13;
  float[(76 & (~ 0)) == 76 ? 1 : -1] array14;
  float[(-32 & (~ 12)) == -32 ? 1 : -1] array15;
  float[(-32 & (~ -6)) == 0 ? 1 : -1] array16;
  float[(-32 & (~ 76)) == -96 ? 1 : -1] array17;
  float[(-32 & (~ -32)) == 0 ? 1 : -1] array18;
  float[(-32 & (~ 0)) == -32 ? 1 : -1] array19;
  float[(0 & (~ 12)) == 0 ? 1 : -1] array20;
  float[(0 & (~ -6)) == 0 ? 1 : -1] array21;
  float[(0 & (~ 76)) == 0 ? 1 : -1] array22;
  float[(0 & (~ -32)) == 0 ? 1 : -1] array23;
  float[(0 & (~ 0)) == 0 ? 1 : -1] array24;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length() + array6.length() + array7.length() + array8.length() + array9.length() + array10.length() + array11.length() + array12.length() + array13.length() + array14.length() + array15.length() + array16.length() + array17.length() + array18.length() + array19.length() + array20.length() + array21.length() + array22.length() + array23.length() + array24.length());
}
