/* [config]
 * expect_result: pass
 * glsl_version: 1.50
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (ivec4(-64, 72, 88, -76) ^ 12) => ivec4(-52, 68, 84, -72)
 * (ivec4(-64, 72, 88, -76) ^ -6) => ivec4(58, -78, -94, 78)
 * (ivec4(-64, 72, 88, -76) ^ 76) => ivec4(-116, 4, 20, -8)
 * (ivec4(-64, 72, 88, -76) ^ -32) => ivec4(32, -88, -72, 84)
 * (ivec4(-64, 72, 88, -76) ^ 0) => ivec4(-64, 72, 88, -76)
 * (ivec4(64, 72, 88, 76) ^ 12) => ivec4(76, 68, 84, 64)
 * (ivec4(64, 72, 88, 76) ^ -6) => ivec4(-70, -78, -94, -74)
 * (ivec4(64, 72, 88, 76) ^ 76) => ivec4(12, 4, 20, 0)
 * (ivec4(64, 72, 88, 76) ^ -32) => ivec4(-96, -88, -72, -84)
 * (ivec4(64, 72, 88, 76) ^ 0) => ivec4(64, 72, 88, 76)
 * (ivec4(-24, 40, -23, 64) ^ 12) => ivec4(-28, 36, -27, 76)
 * (ivec4(-24, 40, -23, 64) ^ -6) => ivec4(18, -46, 19, -70)
 * (ivec4(-24, 40, -23, 64) ^ 76) => ivec4(-92, 100, -91, 12)
 * (ivec4(-24, 40, -23, 64) ^ -32) => ivec4(8, -56, 9, -96)
 * (ivec4(-24, 40, -23, 64) ^ 0) => ivec4(-24, 40, -23, 64)
 * (ivec4(24, 40, 23, 64) ^ 12) => ivec4(20, 36, 27, 76)
 * (ivec4(24, 40, 23, 64) ^ -6) => ivec4(-30, -46, -19, -70)
 * (ivec4(24, 40, 23, 64) ^ 76) => ivec4(84, 100, 91, 12)
 * (ivec4(24, 40, 23, 64) ^ -32) => ivec4(-8, -56, -9, -96)
 * (ivec4(24, 40, 23, 64) ^ 0) => ivec4(24, 40, 23, 64)
 */
#version 150

void main()
{
  float[all(equal((ivec4(-64, 72, 88, -76) ^ 12), ivec4(-52, 68, 84, -72))) ? 1 : -1] array0;
  float[all(equal((ivec4(-64, 72, 88, -76) ^ -6), ivec4(58, -78, -94, 78))) ? 1 : -1] array1;
  float[all(equal((ivec4(-64, 72, 88, -76) ^ 76), ivec4(-116, 4, 20, -8))) ? 1 : -1] array2;
  float[all(equal((ivec4(-64, 72, 88, -76) ^ -32), ivec4(32, -88, -72, 84))) ? 1 : -1] array3;
  float[all(equal((ivec4(-64, 72, 88, -76) ^ 0), ivec4(-64, 72, 88, -76))) ? 1 : -1] array4;
  float[all(equal((ivec4(64, 72, 88, 76) ^ 12), ivec4(76, 68, 84, 64))) ? 1 : -1] array5;
  float[all(equal((ivec4(64, 72, 88, 76) ^ -6), ivec4(-70, -78, -94, -74))) ? 1 : -1] array6;
  float[all(equal((ivec4(64, 72, 88, 76) ^ 76), ivec4(12, 4, 20, 0))) ? 1 : -1] array7;
  float[all(equal((ivec4(64, 72, 88, 76) ^ -32), ivec4(-96, -88, -72, -84))) ? 1 : -1] array8;
  float[all(equal((ivec4(64, 72, 88, 76) ^ 0), ivec4(64, 72, 88, 76))) ? 1 : -1] array9;
  float[all(equal((ivec4(-24, 40, -23, 64) ^ 12), ivec4(-28, 36, -27, 76))) ? 1 : -1] array10;
  float[all(equal((ivec4(-24, 40, -23, 64) ^ -6), ivec4(18, -46, 19, -70))) ? 1 : -1] array11;
  float[all(equal((ivec4(-24, 40, -23, 64) ^ 76), ivec4(-92, 100, -91, 12))) ? 1 : -1] array12;
  float[all(equal((ivec4(-24, 40, -23, 64) ^ -32), ivec4(8, -56, 9, -96))) ? 1 : -1] array13;
  float[all(equal((ivec4(-24, 40, -23, 64) ^ 0), ivec4(-24, 40, -23, 64))) ? 1 : -1] array14;
  float[all(equal((ivec4(24, 40, 23, 64) ^ 12), ivec4(20, 36, 27, 76))) ? 1 : -1] array15;
  float[all(equal((ivec4(24, 40, 23, 64) ^ -6), ivec4(-30, -46, -19, -70))) ? 1 : -1] array16;
  float[all(equal((ivec4(24, 40, 23, 64) ^ 76), ivec4(84, 100, 91, 12))) ? 1 : -1] array17;
  float[all(equal((ivec4(24, 40, 23, 64) ^ -32), ivec4(-8, -56, -9, -96))) ? 1 : -1] array18;
  float[all(equal((ivec4(24, 40, 23, 64) ^ 0), ivec4(24, 40, 23, 64))) ? 1 : -1] array19;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length() + array6.length() + array7.length() + array8.length() + array9.length() + array10.length() + array11.length() + array12.length() + array13.length() + array14.length() + array15.length() + array16.length() + array17.length() + array18.length() + array19.length());
}
