/* [config]
 * expect_result: pass
 * glsl_version: 1.50
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (12 ^ (~ abs(12))) => -1
 * (12 ^ (~ abs(-6))) => -11
 * (12 ^ (~ abs(76))) => -65
 * (12 ^ (~ abs(-32))) => -45
 * (12 ^ (~ abs(0))) => -13
 * (-6 ^ (~ abs(12))) => 9
 * (-6 ^ (~ abs(-6))) => 3
 * (-6 ^ (~ abs(76))) => 73
 * (-6 ^ (~ abs(-32))) => 37
 * (-6 ^ (~ abs(0))) => 5
 * (76 ^ (~ abs(12))) => -65
 * (76 ^ (~ abs(-6))) => -75
 * (76 ^ (~ abs(76))) => -1
 * (76 ^ (~ abs(-32))) => -109
 * (76 ^ (~ abs(0))) => -77
 * (-32 ^ (~ abs(12))) => 19
 * (-32 ^ (~ abs(-6))) => 25
 * (-32 ^ (~ abs(76))) => 83
 * (-32 ^ (~ abs(-32))) => 63
 * (-32 ^ (~ abs(0))) => 31
 * (0 ^ (~ abs(12))) => -13
 * (0 ^ (~ abs(-6))) => -7
 * (0 ^ (~ abs(76))) => -77
 * (0 ^ (~ abs(-32))) => -33
 * (0 ^ (~ abs(0))) => -1
 */
#version 150

void main()
{
  float[(12 ^ (~ abs(12))) == -1 ? 1 : -1] array0;
  float[(12 ^ (~ abs(-6))) == -11 ? 1 : -1] array1;
  float[(12 ^ (~ abs(76))) == -65 ? 1 : -1] array2;
  float[(12 ^ (~ abs(-32))) == -45 ? 1 : -1] array3;
  float[(12 ^ (~ abs(0))) == -13 ? 1 : -1] array4;
  float[(-6 ^ (~ abs(12))) == 9 ? 1 : -1] array5;
  float[(-6 ^ (~ abs(-6))) == 3 ? 1 : -1] array6;
  float[(-6 ^ (~ abs(76))) == 73 ? 1 : -1] array7;
  float[(-6 ^ (~ abs(-32))) == 37 ? 1 : -1] array8;
  float[(-6 ^ (~ abs(0))) == 5 ? 1 : -1] array9;
  float[(76 ^ (~ abs(12))) == -65 ? 1 : -1] array10;
  float[(76 ^ (~ abs(-6))) == -75 ? 1 : -1] array11;
  float[(76 ^ (~ abs(76))) == -1 ? 1 : -1] array12;
  float[(76 ^ (~ abs(-32))) == -109 ? 1 : -1] array13;
  float[(76 ^ (~ abs(0))) == -77 ? 1 : -1] array14;
  float[(-32 ^ (~ abs(12))) == 19 ? 1 : -1] array15;
  float[(-32 ^ (~ abs(-6))) == 25 ? 1 : -1] array16;
  float[(-32 ^ (~ abs(76))) == 83 ? 1 : -1] array17;
  float[(-32 ^ (~ abs(-32))) == 63 ? 1 : -1] array18;
  float[(-32 ^ (~ abs(0))) == 31 ? 1 : -1] array19;
  float[(0 ^ (~ abs(12))) == -13 ? 1 : -1] array20;
  float[(0 ^ (~ abs(-6))) == -7 ? 1 : -1] array21;
  float[(0 ^ (~ abs(76))) == -77 ? 1 : -1] array22;
  float[(0 ^ (~ abs(-32))) == -33 ? 1 : -1] array23;
  float[(0 ^ (~ abs(0))) == -1 ? 1 : -1] array24;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length() + array6.length() + array7.length() + array8.length() + array9.length() + array10.length() + array11.length() + array12.length() + array13.length() + array14.length() + array15.length() + array16.length() + array17.length() + array18.length() + array19.length() + array20.length() + array21.length() + array22.length() + array23.length() + array24.length());
}
