/* [config]
 * expect_result: pass
 * glsl_version: 1.50
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (ivec3(-36, 32, -88) ^ (~ ivec3(-36, 32, -88))) => ivec3(-1, -1, -1)
 * (ivec3(-36, 32, -88) ^ (~ ivec3(36, 32, 88))) => ivec3(7, -1, 15)
 * (ivec3(-36, 32, -88) ^ (~ ivec3(59, 77, 68))) => ivec3(24, -110, 19)
 * (ivec3(36, 32, 88) ^ (~ ivec3(-36, 32, -88))) => ivec3(7, -1, 15)
 * (ivec3(36, 32, 88) ^ (~ ivec3(36, 32, 88))) => ivec3(-1, -1, -1)
 * (ivec3(36, 32, 88) ^ (~ ivec3(59, 77, 68))) => ivec3(-32, -110, -29)
 * (ivec3(59, 77, 68) ^ (~ ivec3(-36, 32, -88))) => ivec3(24, -110, 19)
 * (ivec3(59, 77, 68) ^ (~ ivec3(36, 32, 88))) => ivec3(-32, -110, -29)
 * (ivec3(59, 77, 68) ^ (~ ivec3(59, 77, 68))) => ivec3(-1, -1, -1)
 */
#version 150

void main()
{
  float[all(equal((ivec3(-36, 32, -88) ^ (~ ivec3(-36, 32, -88))), ivec3(-1, -1, -1))) ? 1 : -1] array0;
  float[all(equal((ivec3(-36, 32, -88) ^ (~ ivec3(36, 32, 88))), ivec3(7, -1, 15))) ? 1 : -1] array1;
  float[all(equal((ivec3(-36, 32, -88) ^ (~ ivec3(59, 77, 68))), ivec3(24, -110, 19))) ? 1 : -1] array2;
  float[all(equal((ivec3(36, 32, 88) ^ (~ ivec3(-36, 32, -88))), ivec3(7, -1, 15))) ? 1 : -1] array3;
  float[all(equal((ivec3(36, 32, 88) ^ (~ ivec3(36, 32, 88))), ivec3(-1, -1, -1))) ? 1 : -1] array4;
  float[all(equal((ivec3(36, 32, 88) ^ (~ ivec3(59, 77, 68))), ivec3(-32, -110, -29))) ? 1 : -1] array5;
  float[all(equal((ivec3(59, 77, 68) ^ (~ ivec3(-36, 32, -88))), ivec3(24, -110, 19))) ? 1 : -1] array6;
  float[all(equal((ivec3(59, 77, 68) ^ (~ ivec3(36, 32, 88))), ivec3(-32, -110, -29))) ? 1 : -1] array7;
  float[all(equal((ivec3(59, 77, 68) ^ (~ ivec3(59, 77, 68))), ivec3(-1, -1, -1))) ? 1 : -1] array8;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length() + array6.length() + array7.length() + array8.length());
}
