/* [config]
 * expect_result: pass
 * glsl_version: 1.50
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (ivec2(38, 35) == ivec2(38, 35)) => true
 * (ivec2(38, 35) == ivec2(64, -9)) => false
 * (ivec2(38, 35) == ivec2(64, 9)) => false
 * (ivec2(64, -9) == ivec2(38, 35)) => false
 * (ivec2(64, -9) == ivec2(64, -9)) => true
 * (ivec2(64, -9) == ivec2(64, 9)) => false
 * (ivec2(64, 9) == ivec2(38, 35)) => false
 * (ivec2(64, 9) == ivec2(64, -9)) => false
 * (ivec2(64, 9) == ivec2(64, 9)) => true
 */
#version 150

void main()
{
  float[(ivec2(38, 35) == ivec2(38, 35)) == true ? 1 : -1] array0;
  float[(ivec2(38, 35) == ivec2(64, -9)) == false ? 1 : -1] array1;
  float[(ivec2(38, 35) == ivec2(64, 9)) == false ? 1 : -1] array2;
  float[(ivec2(64, -9) == ivec2(38, 35)) == false ? 1 : -1] array3;
  float[(ivec2(64, -9) == ivec2(64, -9)) == true ? 1 : -1] array4;
  float[(ivec2(64, -9) == ivec2(64, 9)) == false ? 1 : -1] array5;
  float[(ivec2(64, 9) == ivec2(38, 35)) == false ? 1 : -1] array6;
  float[(ivec2(64, 9) == ivec2(64, -9)) == false ? 1 : -1] array7;
  float[(ivec2(64, 9) == ivec2(64, 9)) == true ? 1 : -1] array8;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length() + array6.length() + array7.length() + array8.length());
}
