/* [config]
 * expect_result: pass
 * glsl_version: 1.50
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * (false ? uvec4(66u, 72u, 87u, 75u) : uvec4(66u, 72u, 87u, 75u)) => uvec4(66u, 72u, 87u, 75u)
 * (false ? uvec4(66u, 72u, 87u, 75u) : uvec4(24u, 40u, 23u, 74u)) => uvec4(24u, 40u, 23u, 74u)
 * (false ? uvec4(24u, 40u, 23u, 74u) : uvec4(66u, 72u, 87u, 75u)) => uvec4(66u, 72u, 87u, 75u)
 * (false ? uvec4(24u, 40u, 23u, 74u) : uvec4(24u, 40u, 23u, 74u)) => uvec4(24u, 40u, 23u, 74u)
 * (true ? uvec4(66u, 72u, 87u, 75u) : uvec4(66u, 72u, 87u, 75u)) => uvec4(66u, 72u, 87u, 75u)
 * (true ? uvec4(66u, 72u, 87u, 75u) : uvec4(24u, 40u, 23u, 74u)) => uvec4(66u, 72u, 87u, 75u)
 * (true ? uvec4(24u, 40u, 23u, 74u) : uvec4(66u, 72u, 87u, 75u)) => uvec4(24u, 40u, 23u, 74u)
 * (true ? uvec4(24u, 40u, 23u, 74u) : uvec4(24u, 40u, 23u, 74u)) => uvec4(24u, 40u, 23u, 74u)
 */
#version 150

void main()
{
  float[all(equal((false ? uvec4(66u, 72u, 87u, 75u) : uvec4(66u, 72u, 87u, 75u)), uvec4(66u, 72u, 87u, 75u))) ? 1 : -1] array0;
  float[all(equal((false ? uvec4(66u, 72u, 87u, 75u) : uvec4(24u, 40u, 23u, 74u)), uvec4(24u, 40u, 23u, 74u))) ? 1 : -1] array1;
  float[all(equal((false ? uvec4(24u, 40u, 23u, 74u) : uvec4(66u, 72u, 87u, 75u)), uvec4(66u, 72u, 87u, 75u))) ? 1 : -1] array2;
  float[all(equal((false ? uvec4(24u, 40u, 23u, 74u) : uvec4(24u, 40u, 23u, 74u)), uvec4(24u, 40u, 23u, 74u))) ? 1 : -1] array3;
  float[all(equal((true ? uvec4(66u, 72u, 87u, 75u) : uvec4(66u, 72u, 87u, 75u)), uvec4(66u, 72u, 87u, 75u))) ? 1 : -1] array4;
  float[all(equal((true ? uvec4(66u, 72u, 87u, 75u) : uvec4(24u, 40u, 23u, 74u)), uvec4(66u, 72u, 87u, 75u))) ? 1 : -1] array5;
  float[all(equal((true ? uvec4(24u, 40u, 23u, 74u) : uvec4(66u, 72u, 87u, 75u)), uvec4(24u, 40u, 23u, 74u))) ? 1 : -1] array6;
  float[all(equal((true ? uvec4(24u, 40u, 23u, 74u) : uvec4(24u, 40u, 23u, 74u)), uvec4(24u, 40u, 23u, 74u))) ? 1 : -1] array7;
  gl_Position = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length() + array6.length() + array7.length());
}
