/* [config]
 * expect_result: pass
 * glsl_version: 4.00
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * distance(dvec2(-0.1lf, -1.2lf), dvec2(-0.1lf, -1.2lf)) => 0.0lf
 * distance(dvec2(-0.1lf, -1.2lf), dvec2(-0.42lf, 0.48lf)) => 1.7102046661145558lf
 * distance(dvec2(-0.42lf, 0.48lf), dvec2(-0.1lf, -1.2lf)) => 1.7102046661145558lf
 * distance(dvec2(-0.42lf, 0.48lf), dvec2(-0.42lf, 0.48lf)) => 0.0lf
 */
#version 400

void main()
{
  double[0.0 <= distance(dvec2(-0.1lf, -1.2lf), dvec2(-0.1lf, -1.2lf)) && distance(dvec2(-0.1lf, -1.2lf), dvec2(-0.1lf, -1.2lf)) <= 0.0 ? 1 : -1] array0;
  double[1.7101875640678947 <= distance(dvec2(-0.1lf, -1.2lf), dvec2(-0.42lf, 0.48lf)) && distance(dvec2(-0.1lf, -1.2lf), dvec2(-0.42lf, 0.48lf)) <= 1.7102217681612168 ? 1 : -1] array1;
  double[1.7101875640678947 <= distance(dvec2(-0.42lf, 0.48lf), dvec2(-0.1lf, -1.2lf)) && distance(dvec2(-0.42lf, 0.48lf), dvec2(-0.1lf, -1.2lf)) <= 1.7102217681612168 ? 1 : -1] array2;
  double[0.0 <= distance(dvec2(-0.42lf, 0.48lf), dvec2(-0.42lf, 0.48lf)) && distance(dvec2(-0.42lf, 0.48lf), dvec2(-0.42lf, 0.48lf)) <= 0.0 ? 1 : -1] array3;
  gl_FragColor = vec4(array0.length() + array1.length() + array2.length() + array3.length());
}
