/* [config]
 * expect_result: pass
 * glsl_version: 4.00
 * [end config]
 *
 * Check that the following test vectors are constant folded correctly:
 * notEqual(dvec2(-1.5lf, -1.5lf), dvec2(-1.5lf, -0.5lf)) => bvec2(false, true)
 * notEqual(dvec2(-1.5lf, -1.5lf), dvec2(0.5lf, 1.5lf)) => bvec2(true, true)
 * notEqual(dvec2(-0.5lf, -0.5lf), dvec2(-1.5lf, -0.5lf)) => bvec2(true, false)
 * notEqual(dvec2(-0.5lf, -0.5lf), dvec2(0.5lf, 1.5lf)) => bvec2(true, true)
 * notEqual(dvec2(0.5lf, 0.5lf), dvec2(-1.5lf, -0.5lf)) => bvec2(true, true)
 * notEqual(dvec2(0.5lf, 0.5lf), dvec2(0.5lf, 1.5lf)) => bvec2(false, true)
 * notEqual(dvec2(1.5lf, 1.5lf), dvec2(-1.5lf, -0.5lf)) => bvec2(true, true)
 * notEqual(dvec2(1.5lf, 1.5lf), dvec2(0.5lf, 1.5lf)) => bvec2(true, false)
 */
#version 400

void main()
{
  double[all(equal(notEqual(dvec2(-1.5lf, -1.5lf), dvec2(-1.5lf, -0.5lf)), bvec2(false, true))) ? 1 : -1] array0;
  double[all(equal(notEqual(dvec2(-1.5lf, -1.5lf), dvec2(0.5lf, 1.5lf)), bvec2(true, true))) ? 1 : -1] array1;
  double[all(equal(notEqual(dvec2(-0.5lf, -0.5lf), dvec2(-1.5lf, -0.5lf)), bvec2(true, false))) ? 1 : -1] array2;
  double[all(equal(notEqual(dvec2(-0.5lf, -0.5lf), dvec2(0.5lf, 1.5lf)), bvec2(true, true))) ? 1 : -1] array3;
  double[all(equal(notEqual(dvec2(0.5lf, 0.5lf), dvec2(-1.5lf, -0.5lf)), bvec2(true, true))) ? 1 : -1] array4;
  double[all(equal(notEqual(dvec2(0.5lf, 0.5lf), dvec2(0.5lf, 1.5lf)), bvec2(false, true))) ? 1 : -1] array5;
  double[all(equal(notEqual(dvec2(1.5lf, 1.5lf), dvec2(-1.5lf, -0.5lf)), bvec2(true, true))) ? 1 : -1] array6;
  double[all(equal(notEqual(dvec2(1.5lf, 1.5lf), dvec2(0.5lf, 1.5lf)), bvec2(true, false))) ? 1 : -1] array7;
  gl_FragColor = vec4(array0.length() + array1.length() + array2.length() + array3.length() + array4.length() + array5.length() + array6.length() + array7.length());
}
