/* [config]
 * expect_result: fail
 * glsl_version: 4.00
 * [end config]
 *
 * Declare a default interpolation dmat3 inside a struct.
 *
 * The OpenGL Shading Language 4.00 spec states:
 *
 *    "4.3.4 Inputs
 *    ...
 *        Fragment shader inputs that are signed or unsigned integers,
 *        integer vectors, or any double-precision floating-point type
 *        must be qualified with the interpolation qualifier flat."
 */

#version 400

struct S {
	dmat3 u;
};

in S s;
out vec4 color;

void main()
{
	color = vec4(s.u[0].xyzx);
}
