/* [config]
 * expect_result: pass
 * glsl_version: 4.00
 * [end config]
 *
 * Declare a flat interpolation dvec4.
 *
 * The OpenGL Shading Language 4.00 spec states:
 *
 *    "4.3.4 Inputs
 *    ...
 *        Fragment shader inputs that are signed or unsigned integers,
 *        integer vectors, or any double-precision floating-point type
 *        must be qualified with the interpolation qualifier flat."
 */

#version 400

flat in dvec4 u;
out vec4 color;

void main()
{
	color = vec4(u);
}
