/* [config]
 * expect_result: pass
 * glsl_version: 4.00
 * [end config]
 *
 * Declare a flat interpolation dmat4x2 inside a struct in an interface block.
 *
 * The OpenGL Shading Language 4.00 spec states:
 *
 *    "4.3.4 Inputs
 *    ...
 *        Fragment shader inputs that are signed or unsigned integers,
 *        integer vectors, or any double-precision floating-point type
 *        must be qualified with the interpolation qualifier flat."
 */

#version 400

struct S {
	dmat4x2 u;
};

in IB {
	flat S s;
};
out vec4 color;

void main()
{
	color = vec4(s.u[0].xyxy);
}
