/* [config]
 * expect_result: fail
 * glsl_version: 4.00
 * [end config]
 *
 * Declare a noperspective interpolation dmat4x3 array.
 *
 * The OpenGL Shading Language 4.00 spec states:
 *
 *    "4.3.4 Inputs
 *    ...
 *        Fragment shader inputs that are signed or unsigned integers,
 *        integer vectors, or any double-precision floating-point type
 *        must be qualified with the interpolation qualifier flat."
 */

#version 400

noperspective in dmat4x3 u[4];
out vec4 color;

void main()
{
	color = vec4(u[3][0].xyzx);
}
