/* [config]
 * expect_result: fail
 * glsl_version: 4.00
 * [end config]
 *
 * Declare a smooth interpolation dvec3 in an interface block.
 *
 * The OpenGL Shading Language 4.00 spec states:
 *
 *    "4.3.4 Inputs
 *    ...
 *        Fragment shader inputs that are signed or unsigned integers,
 *        integer vectors, or any double-precision floating-point type
 *        must be qualified with the interpolation qualifier flat."
 */

#version 400

in IB {
	smooth dvec3 u;
};
out vec4 color;

void main()
{
	color = vec4(u.xyzx);
}
